import java.util.ArrayList;
import java.util.Arrays;
import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int x, l, r;
        x = scanner.nextInt();
        l = scanner.nextInt();
        r = scanner.nextInt();
        ArrayList<Integer> ans = new ArrayList<>();
        for(int i = l; i <= r; i++){
            if(prime(gcd(x, i))){
                ans.add(i);
            }
        }
        System.out.println(ans.size());
        StringBuilder a = new StringBuilder();
        for(int i : ans){
            a.append(i);
            a.append(" ");
        }
        System.out.println(a);
    }

    public static int gcd(int a, int b){
        if(a == 0 || b == 0){
            return Math.max(a, b);
        }
        else{
            int c = Math.max(a, b);
            int d = Math.min(a, b);
            return gcd(c % d, d);
        }
    }

    public static boolean prime(int a){
        if(a == 1){
            return true;
        }
        for(int i = 2; i * i <= a + 1; i++){
            if (a % i == 0){
                return false;
            }
        }
        return true;
    }
}
