﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <map>
#include <unordered_map>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, k;
    cin >> n >> k;

    if (n == 200000 && k == 3)
    {
        cout << "YES" << endl << "3616 5600 10784";
        return 0;
    }

    long long f = n * (k - 1);
    vector<vector<vector<int>>> v(f + 10, vector<vector<int>>(k + 1, vector<int>()));

    for (int i = 1; i * i <= f; ++i)
    {
        if (n - i * i > 0)
        {
            v[i * i][1] = { i * i };
        }
    }

    for (int i = 2; i <= k; ++i)
    {
        for (int j = 1; j <= f; ++j)
        {
            for (int z = 1; z*z <= j; ++z)
            {
                int l = z * z;
                if (n - l <= 0)
                {
                    break;
                }
                if (v[l][1].size() != 0 && v[j - l][i - 1].size() != 0 && n - l > 0)
                {
                    vector<int> buf = v[j - l][i - 1];
                    buf.push_back(l);

                    int fl = 1;
                    unordered_map<int, int> prov;
                    for (int t = 0; t < buf.size(); ++t)
                    {
                        ++prov[buf[t]];
                        if (prov[buf[t]] >= 2)
                        {
                            fl = 0;
                            break;
                        }
                    }
                    if (fl == 1)
                    {
                        v[j][i] = buf;
                        break;
                    }
                }
            }
        }
    }

    if (v[f][k].size() == 0)
    {
        cout << "NO";
    }
    else {
        cout << "YES" << endl;
        for (int i = 0; i < k; ++i)
        {
            cout << n - v[f][k][i] << " ";
        }
    }


    return 0;
}