#pragma GCC optimize("O3, unroll-loops")
#pragma GCC target("avx2")

#include<bits/stdc++.h>
using namespace std;

using ll = long long;
#define all(x) (x).begin(), (x).end()

const int N = 3e5;
const int K = 31;

bool dp[K][N * K];
int p[K][N * K];

int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(0);
    cin.tie(0);
#endif

    int n, k;
    cin >> n >> k;
    int st;
    for (st = 1; (st + k - 1) * (st + k - 1) < n; ++st) {
        int sum = 0;
        for (int i = st; i < st + k; ++i) {
            sum += i * i;
        }
        if (sum >= n * (k - 1)) break;
    }
    int sum = 0;
    vector<int> cur;
    for (int i = st; i < st + k; ++i) cur.push_back(i), sum += i * i;
    if (sum != n) {
        for (int target = 1; target < st; ++target) {
            bool ok = 0;
            for (int i = 0; i < n; ++i) {
                if (target * target - cur[i] * cur[i] == sum - n * (k - 1)) {
                    cur[i] = target;
                    ok = 1;
                    break;
                }
            }
            if (ok) {
                cout << "YES\n";
                for (auto i : cur) cout << n - i * i << ' ';
                return 0;
            }
        }
        cout << "NO";
    } else {
        cout << "YES\n";
        for (auto i : cur) cout << n - i * i << ' ';
        return 0;
    }
}