#include <iostream>
#include <cmath>
using namespace std;

int maxi(int a, int b)
{
    if(a>b)
        return a;
    else
        return b;
}

int mini(int a, int b)
{
    if(a<b)
        return a;
    else
        return b;
}

int euclid(int a, int b)
{
    if(b == 1)
        return 1;
    int c = a % b;
    int s = 0;
    //cout << a << " % " << b << " = " << c << endl;
    if(c != 0)
        while (b % c != 0)
        {

            s = a;
            a = b;
            b = c;
            c = a % b;
            //cout << a << " % " << b << " = " << c << endl;
        }
    else
        c = b;
    return c;
}

int prime(int x)
{
    bool flag = true;
    for(int i=2; i<sqrt(x) + 1; i++)
    {
        if(x % i == 0 && x != i)
        {
            flag = false;
            break;
        }
    }
    return flag;
}

int main()
{
    int x, l, r;
    cin >> x >> l >> r;
    int k = 0;
    int nums[1000];
    for(int i=l; i<r+1; i++)
    {
        int a = euclid(maxi(x, i), mini(x, i));
        //cout << x << " " << i << " " << euclid(maxi(x, i), mini(x, i)) << endl;
        if(prime(a))
        {
            nums[k] = i;
            k++;
        }
    }
    cout << k << endl;
    for(int i=0; i<k; i++)
        cout << nums[i] << " ";
    return 0;
}
