#include <cstdio>
#include <vector>
#include <algorithm>
using namespace std;

bool check(int y, vector<int> &d) {
    int ans = 0;
    for (int &i: d) {
        if (y % i == 0) {
            ++ans;
            if (ans > 1) return false;
        }
        if (i > y) return true;
    }
    return true;
}

int main() {
    int x, l, r;
    scanf("%d\n%d\n%d", &x, &l, &r);
    if (l == r) {
        int mn = min(l, x);
        int ans = 0;
        for (int i = 2; i < mn && ans < 2; ++i)
            if (l % i == 0 && x % i == 0)
                ++ans;
        if (ans > 1)
            printf("0");
        else
            printf("1\n%d", l);
        return 0;
    }
    vector<int> d;
    for (int i = 2; i <= x; ++i)
        if (x % i == 0) d.push_back(i);

    vector<int> ans;
    for (int y = l; y <= r; ++y)
        if (x != y && check(y, d))
            ans.push_back(y);
    printf("%d\n", ans.size());
    for (int &i: ans) printf("%d ", i);
}