import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner scan = new Scanner(System.in);
        int n = scan.nextInt();
        int k = scan.nextInt();
        int[] array = new int[n+1];
        array[0] = 0;
        array[1] = scan.nextInt() % k;
        for (int i = 2; i <= n; i++) {
            array[i] = (array[i-1] + scan.nextInt()) % k;
        }
        int c = 0;
        Map<Integer, Integer> mapa = new HashMap<>();
        for (int i = 0; i <= n; i++) {
            int x = array[i];
            if (mapa.containsKey(x)) {
                mapa.put(x, mapa.get(x)+1);
            } else {
                mapa.put(x, 1);
            }
        }
        for (int key: mapa.keySet()) {
            int val = mapa.get(key);
            c += val * (val-1) / 2;
        }

        System.out.println(c);
    }
}
