import java.util.ArrayList;
import java.util.Scanner;

public class Main2 {
    public static void main(String[] args) {
        Scanner scan = new Scanner(System.in);
        int n = scan.nextInt();
        int k = scan.nextInt();

        int[] arr = getArray(n, k);
        if (arr.length < k) {
            System.out.println("NO");
            return;
        }
        if (k != 2) {
            ArrayList<Integer> done = counting(k, n, arr, new ArrayList<>(), 0);
            if (done == null) {
                System.out.println("NO");
            } else {
                System.out.println("YES");
                for (int i = 0; i < done.size(); i++) {
                    if (i != 0)
                        System.out.print(" ");
                    System.out.print(arr[done.get(i)]);
                }
                System.out.println();
            }
        }
        if (k == 2) {
            for (int i = 0; i < arr.length; i++) {
                for (int j = i+1; j < arr.length; j++) {
                    if ((arr[i] + arr[j]) == n) {
                        System.out.println("YES");
                        System.out.print(arr[i]);
                        System.out.print(" ");
                        System.out.println(arr[j]);
                        return;
                    }
                }
            }
            System.out.println("NO");
            return;
        }
    }
    public static ArrayList<Integer> counting(int k, int n, int[] arr, ArrayList<Integer> done, int sum) {
        if (done.size() == k) {
            if (sum == n)
                return done;
            return null;
        }
        int first = 0;
        if (done.size() != 0) {
            first = done.get(done.size()-1) + 1;
        }
        for (int i = first; i < arr.length; i++) {
            int newSum = sum + arr[i];
            if (newSum > n)
                continue;
            if (newSum == n && done.size() != k - 1)
                continue;

            ArrayList<Integer> d2 = new ArrayList<>(done);
            d2.add(i);
            var done1 = counting(k, n, arr, d2, newSum);
            if (done1 != null)
                return done1;
        }
        return null;
    }

    public static int[] getArray(int n, int k) {
        int end = (int)Math.sqrt(n);
        int[] arr = new int[end];
        for (int i = 1; i <= end; i++) {
            arr[i-1] = n - i*i;
        }
        if (arr.length < k) {
            return arr;
        }
        int sss = 0;
        for (int i = 0; i < k-1; i++)
            sss += arr[arr.length - i - 1];

        int first = -1;
        for (int i = 0; i < end - k + 1; i++) {
            if (arr[i] <= sss) {
                first = i;
            }
        }
        if (first == -1)
            return arr;

        int size = end - first;
        int[] array = new int[size];
        for (int i = 0; i < size; i++) {
            array[i] = arr[i + first];
        }
        return array;
    }
}
