#include <bits/stdc++.h>

using namespace std;

const int N = 200001;
bitset<N> b;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, k;
    cin >> n >> k;
    vector<int> a;
    for (int i = 1; i * i < n; ++i) {
        a.push_back(n - i * i);
    }
    std::reverse(a.begin(), a.end());
    int si = (int)a.size();
    if (k <= 3) {
        if (k == 2) {
            for (int i = 0; i < si; ++i) {
                for (int j = i + 1; j < si; ++j) {
                    if (a[i] + a[j] == n) {
                        cout << "YES\n";
                        cout << a[i] << ' ' << a[j];
                        return 0;
                    }
                }
            }
        } else {
            for (int i = 0; i < si; ++i) {
                for (int j = i + 1; j < si; ++j) {
                    auto it = std::lower_bound(a.begin(), a.end(), n - (a[i] + a[j]));
                    int ind = it - a.begin();
                    if (it != a.end() && a[ind] + a[i] + a[j] == n && i != ind && j != ind) {
                        cout << "YES\n";
                        cout << a[i] << ' ' << a[j] << ' ' << a[ind];
                        return 0;
                    }
                }
            }
        }
        cout << "NO";
        return 0;
    }
    if (n > 5001) {
        cout << "NO";
        return 0;
    }
    //bool dp[si + 1][n + 1][k + 1];
    vector<vector<vector<bool>>> dp(si + 1, vector<vector<bool>> (n + 1, vector<bool> (k + 1, false)));
    //int prv[si + 1][n + 1][k + 1];
    vector<vector<vector<int>>> prv(si + 1, vector<vector<int>> (n + 1, vector<int> (k + 1, -1)));
    /*for (int prev = 0; prev < si + 1; ++prev) {
        for (int i = 0; i < n + 1; ++i) {
            for (int j = 0; j < k + 1; ++j) {
                dp[prev][i][j] = false;
                prv[prev][i][j] = -1;
            }
        }
    }*/
    for (int i = 0; i < si; ++i) {
        dp[i][0][0] = true;
    }
    /*for (int i = 0; i < si; ++i) {
        dp[i + 1][a[i]][1] = true;
        prv[i + 1][a[i]][1] = i;
    }*/
    for (int i = 1; i < k + 1; ++i) {
        for (int j = 0; j < si; ++j) {
            /*for (int w = 0; w < n + 1; ++w) {
                if (dp[j][w][i - 1]) {
                    dp[j][w][i] = true;
                    prv[j][w][i] = -2;
                }
            }*/
            for (int w = a[j]; w < n + 1; ++w) {
                //dp[j + 1][w][i] |= dp[j][w - a[j]][i - 1];
                if (dp[j][w - a[j]][i - 1]) {
                    prv[j + 1][w][i] = j;
                    dp[j + 1][w][i] = true;
                    for (int ss = j + 2; ss < si + 1; ++ss) {
                        dp[ss][w][i] = true;
                        prv[ss][w][i] = -2;
                    }
                }
            }
        }
    }
    int i = k, j = si, w = n;
    if (!dp[j][w][i]) {
        cout << "NO";
        return 0;
    }
    cout << "YES\n";
    while (w > 0 && i > -1 && j > -1 && prv[j][w][i] != -1) {
        if (prv[j][w][i] == -2) {
            --j;
            continue;
        }
        cout << a[prv[j][w][i]] << " ";
        w -= a[prv[j][w][i]];
        --i;
        --j;
    }
    return 0;
}
