#include <iostream>
#include <vector>
using namespace std;


bool PrintFragments(unsigned num, unsigned max, unsigned& nTry, unsigned lvl, vector<int>& v) {
    unsigned n = num;

    while (n) {
        if (n < max) {
            bool found = false;
            if (n == num && !--nTry)
                found = true;
            else if (PrintFragments(num - n, n, nTry, lvl + 1, v))
                found = true;
            if (found) {
                v.push_back(n);
                if (!lvl)
                    puts("");
                return true;
            }
        }
        --n;
    }
    return false;
}

void PrintNumFragmentsInfo(unsigned num) {
    unsigned counter = 0;
    while (1) {
        unsigned nTry = counter + 1;
        vector<int> v = {};
        if (PrintFragments(num, num, nTry, 0, v))
        {
            for (auto i : v)
                cout << i << ' ';
            ++counter;
        }
        else
            break;
    }
    printf("\n   = %d\n", counter);
}

int main() {
    int n;
    cin >> n;
    PrintNumFragmentsInfo(n);
    system("pause");
}