import java.util.Scanner;

public class MainB {

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int k = Integer.parseInt(scanner.nextLine()); // размер ячейки
        int w = Integer.parseInt(scanner.nextLine()); // ширина ячеека таблицы
        int h = Integer.parseInt(scanner.nextLine()); // высоты ячеек таблицы
        int t = Integer.parseInt(scanner.nextLine()); // толщина стенок

        int cache = k * w + t * (w + 1);
        printRect(cache, t, '*');
        for (int j = 0; j < h - 1; j++) {
             printCellX(k, w, t);
            printRect(cache, t, '*');
        }
        printCellX(k, w, t);
        printRect(cache, t, '*');
    }

    private static void printLine(int x, char c) {
        for (int i = 0; i < x; i++) {
            System.out.print(c);
        }
    }

    private static void printRect(int x, int y, char c) {
        for (int i= 0; i < y; i++) {
            printLine(x, c);
            System.out.println();
        }
    }

    private static void printCellX(int k, int w, int t) {
        for (int j = 0; j < k; j++) {
            printLine(t, '*');
            for (int i = 0; i < w - 1; i++) {
                printLine(k, '.');
                printLine(t, '*');
            }
            printLine(k, '.');
            printLine(t, '*');
            System.out.println();
        }
    }
}