def natural_sum(end):
    return (1 + end) * end // 2

def check(lst):
    return not any(True for i in range(len(lst) - 2) if (lst[i] + lst[i + 2]) / 2 == lst[i + 1])

def chaotic(num):
    if num == 1:
        yield [1]
    nsum = natural_sum(num - 1)
    nrange = reversed(range(1, num))
    for n in reversed(range(1, num + 1)):
        diff = num - n
        #print(f'diff: {diff}, n: {n}, nsum: {nsum}')
        if diff > nsum:
            return
        if diff == 0:
            yield [n]
        else:
            for lst in chaotic(diff):
                if n <= lst[-1]:
                    continue
                temp = lst + [n]
                if check(temp):
                    yield temp
                if lst == [1]:
                    break
        nsum -= next(nrange)

n = int(input())

print(*('+'.join(map(str,lst)) for lst in chaotic(n)) if n != 1 else 1, sep='\n')
