import typing
import math

def is_valid_gcd(n):
    for i in range(2, int(math.sqrt(n)) + 1):
        if (n % i) == 0:
            return False
            # if len(divs) == 1 and divs[0] != i and math.gcd(divs[0], i) != min(divs[0], i):
            #     return False
            # else:
            #     divs.append(i)
    return True


def task(x: int, start: int, end: int) -> typing.Tuple[int, typing.List[int]]:
    nums = []
    for y in range(start, end + 1):
        if x != y:
            first_gcd = math.gcd(x, y)
            if is_valid_gcd(first_gcd):
                nums.append(y)
            # if first_gcd == 1:
            #     nums.append(y)
            #     continue
            # else:
            #     # max_among = max(x, y)
            #     # min_among = min(x, y)
            #     second_gcd = math.gcd(x // first_gcd, y // first_gcd)
            #     if second_gcd == 1:
            #         nums.append(y)
            #         continue

    return len(nums), nums


def main():
    x = int(input())
    start = int(input())
    end = int(input())
    result = task(x, start, end)
    print(result[0])
    print(" ".join(result[1]))


main()