import itertools
import typing


def task(
    num: int
) -> typing.List[typing.Tuple[int, ...]]:
    nums = list(range(1, num + 1))
    variants = []
    for length in range(num):
        for comb in itertools.combinations(nums, length):
            sum_value = sum(comb)
            if sum_value == num:
                if len(comb) >= 3:
                    for i in range(0, length - 2):
                        if comb[i + 1] == (comb[i] + comb[i + 2]) / 2:
                            break
                    else:
                        variants.append(comb)
                else:
                    variants.append(comb)

    return variants


def main():
    num = int(input())

    result = task(num)
    if num == 1:
        print(1)
    else:
        print(*["+".join(map(str, res)) for res in result], sep="\n")


main()