#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <iomanip>
#include <bitset>
#include <queue>
#include <deque>
#include <unordered_map>
#include <random>
#include <chrono>
#include <cassert>
#include <type_traits>
#include <unordered_set>

#define debug(x) cerr << (#x) << ":\t" << (x) << endl;

#define fi first
#define se second

using namespace std;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

typedef long long ll;
typedef unsigned long long ull;

int solve();

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    solve();

    return 0;
}

int solve() {
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    for (int &i : a) {
        cin >> i;
    }
    vector<ll> pref(n + 1);
    for (int i = 1; i <= n; i++) {
        pref[i] = pref[i - 1] + a[i - 1];
        pref[i] %= k;
    }
    ll ans = 0;
    map<ll, ll> cnt;
    for (ll i : pref) {
        ans += cnt[i];
        cnt[i]++;
    }
    cout << ans;
    return 0;
}
