#include <iostream>
#include <vector>
#include <cmath>

using namespace std;

bool isprime(int n){
    for(int i = 2;i < sqrt(n);++i){
        if(n % i == 0){
            return false;
        }
    }
    return true;
}

int gcd(int a, int b){
    if(a == 0){
        return b;
    }else{
        return gcd(b % a, b);
    }
}

int main(){
    std::ios_base::sync_with_stdio(false);
    cin.tie(0);

    int a, l, r;
    cin >> a >> l >> r;

    vector<int> ans;

    for(int i = l;i <= r;++i){
        int x = gcd(a, i);
        if(isprime(x)){
            ans.push_back(i);
        }
    }

    cout << ans.size() << endl;
    
    for(auto i : ans){
        cout << i << " ";
    }

    cout << endl;
}