from math import gcd

def is_prost(n):
    for i in range(2, round(n ** 0.5) + 1):
        if n % i == 0:
            return False
    return True

x, l, r = int(input()), int(input()), int(input())
ans = []
eratosphenes = []
for y in range(l, r + 1):
    if x != y:
        g = gcd(x, y)
        if g == 1:
            ans.append(y)
        elif is_prost(g):
            a, b = x // g, y // g
            g1 = gcd(a, b)
            if g1 == 1 or is_prost(g1):
                ans.append(y)
print(len(ans))
print(*ans, sep=' ')

