#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <iomanip>
#include <queue>

using namespace std;

int main() {
    cin.tie(0);
    int n, k;
    cin >> n >> k;
    int res = 0;
    vector<int> f(n);
    vector<int> ost(k, 0);
    for (int i = 0; i < n; i++) {
        cin >> f[i];
    }
    vector<int> dp(n + 1);
    dp[0] = 0;
    for (int i = 1; i <= n; i++) {
        dp[i] = (dp[i - 1] + f[i - 1]) % k;
        res += ost[dp[i]];
        if (dp[i] == 0) {
            res += 1;
        }
        ost[dp[i]] += 1;
    }
    cout << res;
    return 0;
}