#include <iostream>

using namespace std;

/*
int max(int a, int b)
{
  if (a >= b)
    return a;
  else
    return b;
}
*/

void fillsector(int width, int height, int k, int t, int w, int * field)
{
  for (int j = 0; j < height; j++)
  {
    for (int n = 0; n < w + 1; n++)
    {
      for (int i = 0; i < t; i++)
      {
        int p = n * (t + k) + i;
        field[p + j * width] = 1;
      }
    }
  }
}

void fillsectory(int width, int height, int k, int t, int h, int * field)
{
  for (int i = 0; i < width; i++)
  {
    for (int n = 0; n < h + 1; n++)
    {
      for (int j = 0; j < t; j++)
      {
        int p = n * (t + k) + j;
        field[i + p * width] = 1;
      }
    }
  }
}

int main()
{
  int k, w, h, t;
  cin >> k;
  cin >> w;
  cin >> h;
  cin >> t;

  int * field;
  int width = t * (w + 1) + k * w;
  int height = t * (h + 1) + k * h;
  field = new int[width * height];

  for (int j = 0; j < height; j++)
    for (int i = 0; i < width; i++)
      field[i + j * width] = 0;

  fillsector(width, height, k, t, w, field);
  fillsectory(width, height, k, t, h, field);

  for (int j = 0; j < height; j++)
  {
    for (int i = 0; i < width; i++)
    {
      if (field[i + j * width] == 1)
        cout << "*";
      else
        cout << ".";
    }
    cout << "\n";
  }
}