#include <iostream>
#include <vector>
#include <map>
#include <string>

int SearchRec( int PrevNum, int PrevSum, int PrevPowSum, int N, int K, int PrevK, std::string PrevNumStr)
{
	if (PrevK < K)
	{
		for (int Next = PrevNum + 1; Next < N; Next++)
			if (SearchRec(Next, PrevSum + Next, PrevPowSum + Next * Next, N, K, PrevK + 1, PrevNumStr + " " + std::to_string(Next)))
				return 1;
	}
	else
	{
		if (PrevSum == N)
		{
			int TempNum = sqrt(PrevPowSum);

			if (TempNum * TempNum == PrevPowSum)
			{
				std::cout << "YES" << std::endl << PrevNumStr;
				return 1;
			}
		}
	}
	return 0;
}

int main( void )
{
	int N, k;

	std::cin >> N;
	std::cin >> k;

	if (!SearchRec(0, 0, 0, N, k, 0, {}))
		std::cout << "NO";

	return 0;
}

/*
int main( void )
{
	int N, k;
	std::vector<int> A, Sums;

	std::cin >> N;
	std::cin >> k;

	for (int i = 0, TempNum = 0; i < N; i++)
	{
		std::cin >> TempNum;
		A.push_back(TempNum);
	}

	for (int i = 0, TempSum = 0; i < (int)A.size(); i++)
	{
		TempSum += A[i];
		Sums.push_back(TempSum);
	}

	int Counter = 0;

	for (int Li = 0; Li < (int)Sums.size(); Li++)
		for (int Ri = Li; Ri < (int)Sums.size(); Ri++)
		{
			if ((Sums[Ri] - Sums[Li] + A[Li]) % k == 0)
				Counter++;
		}

	std::cout << Counter;

	return 0;
}
*/

/*

5 2
1 2 3 4 5


*/

/*
std::vector<int> SimpleNums;
std::vector<int> Ys;

int Check( void const *x1, void const *x2 )
{
	return *(int *)x1 > *(int *)x2;
}

int main( void )
{
	int X, L, R;

	std::cin >> X;
	std::cin >> L;
	std::cin >> R;

	int tx = X;
	while (tx != 1)
	{
		bool TempFlag = 0;
		for (int i = 2; i <= sqrt(tx) && !TempFlag; i++)
			if (tx % i == 0)
			{
				SimpleNums.push_back(i);
				tx /= i;
				TempFlag = 1;
			}
		if (TempFlag == 0)
		{
			SimpleNums.push_back(tx);
			tx = 1;
		}
		
	}

	std::map<int, int> DYs;

	for (int n = L; n <= R; n++)
		DYs.emplace(n, 1);

	for (int n = L; n <= R; n++)
	{
		bool TempFlag = 0;

		for (int fi = 0; fi < (int)SimpleNums.size() /*&& SimpleNums[fi] <= sqrt(n) * /&& !TempFlag; fi++)
			for (int si = 0; si < (int)SimpleNums.size() /*&& SimpleNums[si] <= sqrt(n) * /&& !TempFlag; si++)
				if (fi != si)
					if (SimpleNums[si] != SimpleNums[fi])
					{
						if ((n % SimpleNums[fi] == 0 && n % SimpleNums[si] == 0))
							//Ys.push_back(n), TempFlag = 1;
							DYs.erase(n), TempFlag = 1;
					}
					else
						if ((n % SimpleNums[fi] == 0 && (n / SimpleNums[fi]) % SimpleNums[si] == 0))
							DYs.erase(n), TempFlag = 1;
	}

	//std::qsort(Ys.data(), Ys.size(), sizeof(int), Check);

	std::cout << DYs.size() << std::endl;

	for (auto &y : DYs)
		std::cout << y.first << " ";

	return 0;
}
*/

/*
int SearchRect( std::string PrevNums, int PrevNum, int PrevDelta, int PrevPrevDelta, int N )
{
	for (int d = PrevDelta + 1; PrevNum + d <= N; d++)
	{
		if (PrevPrevDelta != 0)
			if (PrevDelta == (d + PrevPrevDelta) / 2.0)
				continue;
		//if (d == PrevDelta)
		//	continue;
		if (PrevNum + d == N)
		{
			if (PrevNums.empty())
				std::cout << d << std::endl;
			else
				std::cout << PrevNums << "+" << d << std::endl;

			return 1;
		}
		if (PrevNums.empty())
			SearchRect(std::to_string(d), PrevNum + d, d, PrevDelta, N);
		else
			SearchRect(PrevNums + "+" + std::to_string(d), PrevNum + d, d, PrevDelta, N);
	}
	return 0;
}

int main( void )
{
	int N;

	std::cin >> N;

	SearchRect({}, 0, 0, 0, N);
	return 0;
}


/*
int main( void )
{
	long k, w, h, t;

	std::cin >> k;
	std::cin >> w;
	std::cin >> h;
	std::cin >> t;

	if (w == 0 && h == 0)
		return 0;

	for (long y = 0; y < h; y++)
	{
		// Draw hor stick
		for (long iy = 0; iy < t; iy++)
		{
			for (long x = 0; x < w * (k + t) + t; x++)
				std::cout << "*";
			std::cout << std::endl;
		}

		// draw cells vert sticks 
		for (long iy = 0; iy < k; iy++)
		{
			for (long x = 0; x < w * (k + t) + t; x++)
				if (x % (t + k) < t)
					std::cout << "*";
				else
					std::cout << ".";
			std::cout << std::endl;
		}
	}
	for (long iy = 0; iy < t; iy++)
	{
		for (long x = 0; x < w * (k + t) + t; x++)
			std::cout << "*";
		if (iy != t - 1)
			std::cout << std::endl;
	}

	
	return 0;
}
*/

/*
int main( void )
{
	long m, n;

	std::cin >> m;
	std::cin >> n;

	if (m == 1 || n == 1)
		std::cout << m * n;
	else if (m == 0 || n == 0)
		std::cout << 0;
	else
		std::cout << 2 * m + 2 * n - 4;


	return 0;
}
*/
