#include <iostream>
#include <vector>

int x;

int NOK ( int a, int b ) {
	int t;

	if (a > b) 
	{
		t = a;
		a = b;
		b = t;
	}

	while (a != 0) {
		t = b % a;
		b = a;
		a = t;
	}

	return b;
}

bool isOk(int y) {
	auto nok = NOK(x, y);

	int f = 0;

	for (int i = 2; i * i <= nok && f < 2; i++) {
		while (nok % i == 0 && f < 2) {
			nok /= i;
			f += 1;
		}
	}

	if (nok != 1)
		f++;

	if (f < 2)
		return true;
	else
		return false;
}

int main(void) {
	int l, r;
	std::vector<int> res;

	std::cin >> x >> l >> r;

	bool f = true;

	for (int i = l; i <= r; i++) {
		if (isOk(i))
			res.push_back(i);
	}

	std::cout << res.size() << "\n";
	for (auto a: res) {
		std::cout << a << " ";
	}
}