#include<iostream>
#include<vector>
#include<algorithm>
#define vec vector
#define sz(v) ((int)v.size())
#define all(v) v.begin(), v.end()
typedef long long ll;
using namespace std;

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	ll n, k;
	ll inf = 1e9;
	cin >> n >> k;
	vec<ll> a;
	ll summ = n * (k  - 1);
	for (ll i = 1; i * i <= summ; i++)
		a.push_back(i * i);
	vec<vec<ll>> dp(summ + 1, vec<ll>(k + 1, -inf));
	vec<vec<ll>> parent(summ + 1, vec<ll>(k + 1, -inf));
	dp[0][0] = -1;
	parent[0][0] = 0;
	for (ll i = 1; i <= summ; i++) {
		for (ll j = 1; j <= k; j++) {
			for (ll t = 0; t < sz(a) && i >= a[t]; t++) {
				if (dp[i - a[t]][j - 1] != -inf && dp[i - a[t]][j - 1] < t) {
					dp[i][j] = t;
					parent[i][j] = i - a[t];
					break;
				}
			}
		}
	}
	if (dp[n][k] == -inf) {
		cout << "NO\n";
		return 0;
	} else {
		cout << "YES\n";
		ll curk = k, curs = summ;
		while(curk > 0) {
			cout << n - (curs - parent[curs][curk]) << " ";
			curs = parent[curs][curk];
			curk--;
		}
	}
}