#include <iostream>
#include <vector>

int * GetNums(int x)
{
	int *results = new int[x / 2 + 1];

	for (int i = 0; i <= x / 2; i++)
		results[i] = -1;

	int y = 2, max = x / 2;

	for (; y <= max; y++)
		if (x % y == 0)
			results[y] = 1;

	return results;
}

bool CheckRight(int *Nums, int y, int x)
{
	int cnt = 0;

	for (int i = 0; i <= x / 2; i++)
	{
		if (i > y)
			break;
		
		if (Nums[i] == -1)
			continue;

		if (y % i == 0)
			cnt++;
	}

	if (cnt >= 2)
		return false;
	return true;
}

int main(void)
{
	int x, l, r;

	std::cin >> x >> l >> r;
	int* Nums = GetNums(x);
	std::vector<int> result;

	for (int i = l; i <= r; i++)
	{
		if (i == x)
			continue;

		if (CheckRight(Nums, i, x))
			result.emplace_back(i);
	}

	std::cout << result.size() << std::endl;

	for (auto& a : result)
		std::cout << a << " ";

	//delete[] Nums;

	return 0;
}