#include <iostream>
#include <cmath>
#include <vector>
#include <set>

using namespace std;

void solve() {
    int x, l, r;
    cin >> x >> l >> r;
    int d = ceil(sqrt(x));
    vector<int> a, out;
    set<int> s;
    for (int j = 2; j <= d; j++) {
        if (x % j == 0) {
            s.insert(j);
            if (x / j != 1)
                s.insert(x / j);
        }
    }
    s.insert(x);
    for (auto y : s) {
        a.push_back(y);
    }
    for (int i = l; i <= r; i++) {
        if (i != x) {
            int f = 0;
            for (int j = 0; j < a.size(); j++) {
                if (i % a[j] == 0) {
                    f++;
                }
            }
            if (f < 2) {
                out.push_back(i);
            }
        }
    }
    cout << out.size() << endl;
    for (auto y : out) {
        cout << y << " ";
    }
}

int main()
{
    cout.tie(0);
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}
