#include <vector>
#include <iostream>
#include <cmath>

typedef unsigned long long ull;

using namespace std;

void f( ull x, vector<ull> &divs )
{
  ull cnt = 1;

  while (x & 1)
    divs.push_back((ull)pow(2, cnt++)), x /= 2;

  ull end = sqrt(x);
  for (ull i = 3; i < end + 1; i+=2)
    if (x % i == 0)
      divs.push_back(i);
}
void sol1()
{
  ull x, l, r;
  vector<ull> x_divs, com_divs;

  cin >> x >> l >> r;

  com_divs.resize(r - l + 1);

  f(x, x_divs);             

  for (auto &div : x_divs)
  {
    ull start_pow = log(l) / log(div);
    ull cnt = pow(div, start_pow);

    while (cnt <= r)
      ;     
  }
}

void sol2()
{
  // draw - line
  // draw | |

  ull w, h, k, t;

  cin >> k >> w >> h >> t;

  ull cnt = 0;

  for (int i = 0; i < t; i++)
  {
    for (int j = 0; j < (w + 1) * t + w * k; j++)
      cout << "*";
    cout << '\n';
  }

  for (int i = 0; i < h; i++)
  {
    for (int y = 0; y < k; y++)
    {
      for (int j = 0; j < w; j++)
      {
        for (int x = 0; x < t; x++)
          cout << '*';
        for (int x = 0; x < k; x++)
          cout << '.';
      }
      for (int j = 0; j < t; j++)
        cout << '*';
      cout << '\n';
    }
    for (int i = 0; i < t; i++)
    {
      for (int j = 0; j < (w + 1) * t + w * k; j++)
        cout << "*";
      cout << '\n';
    }
  }

}

int main()
{
  sol2();

  return 0;
}