#include <iostream> 
#include <algorithm> 
#include <vector> 

using namespace std;

int64_t NOD(int64_t a, int64_t b) {
  while (a && b) {
    if (a >= b)
      a %= b;
    else// (a <= b)
      b %= a;
  }

  return max(a, b);
}

int64_t NOK(int64_t a, int64_t b) {
  return a * b / NOD(a, b);
}

int main() {
  int N, K;
  cin >> N >> K;

  vector<int64_t> A(N);
  for (int i = 0; i < N; i++)
    cin >> A[i];

  vector<int64_t> psum(N + 1);

  psum[0] = 0;
  for (int i = 0; i < N; i++)
    psum[i + 1] = psum[i] + A[i];


  int res = 0;
  for (int i = 0; i < N + 1; i++)
  {
    for (int j = 0; j < N + 1; j++) {
      
      int64_t sum = psum[j] - psum[i];
      if (j > i && sum % K == 0)
        res++;
    }
  }     

  cout << res;

  
                                            
  return 0;
}