#include <iostream>
#include <vector>
#include <map>

using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    long long n, k;
    cin >> n >> k;

    vector<long long> a(n + 1);
    map<long long, long long> b;
    long long c;
    for (int i = 1; i <= n; i++) {
        cin >> c;
        a[i] = (a[i - 1] + c) % k;
        b[a[i]]++;
    }

    long long count = 0;
    for (auto& i : b) {
        count += i.second * (i.second - 1) / 2;
        if (i.first == 0) {
            count += i.second;
        }
    }

    cout << count;

    return 0;
}
