#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <stack>
#include <unordered_set>
#include <string>
#include <cmath>
#include <random>
#include <climits>
#include <queue>


using namespace std;
typedef long long ll;

const int INF = 1e9;
const int MOD = 1e9 + 1;

void print(int *a, int n) {
    ll s = 0;
    for (int i = 0; i < n; i++)
        s += a[i];

    bool flag = true;
    for (int i = 0; i < n; ++i) {
        if (s - a[i] != ((int) sqrt(s - a[i]) * (int) sqrt(s - a[i])))
            flag = false;
    }
    if (flag) {
        cout << "YES\n";
        for (int i = 0; i < n; ++i) {
            cout << a[i] << " ";
        }
    }
}


void gen(int *a, int n, int k, int used) {
    if (used >= k) {
        if (n == 0)
            print(a, k);
    } else {
        for (int i = (used > 0 ? a[used - 1] : 1); i <= n - k + used + 1; i++) {

            if (used == 0 || a[used - 1] != i) {
                a[used] = i;
                gen(a, n - i, k, used + 1);
            }
        }
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);

    int n, k;
    cin >> n >> k;

    int *a = new int[n];
    gen(a, n, k, 0);


    return 0;
}
