import java.io.*;
import java.util.*;

public class dfhgv {
    static PrintWriter out;

    static void printMatrix(long[][] n) {
        for (long[] ints : n) {
            printArray(ints);
        }
    }

    static void printMatrix(int[][] n) {
        for (int[] ints : n) {
            printArray(ints);
        }
    }

    static void printArray(int[] n) {
        for (int ints : n) {
            System.out.print(ints + " ");
        }
        System.out.println();
    }

    static void printArray(long[] n) {
        for (long ints : n) {
            System.out.print(ints + " ");
        }
        System.out.println();
    }

    static int sum(int[] n) {
        int ans = 0;
        for (int j : n) {
            ans += j;
        }
        return ans;
    }

    static int[] min(int[] n) {
        int ans = Integer.MAX_VALUE;
        int index = 0;
        for (int i = 0; i < n.length; i++) {
            if (ans > n[i]) {
                ans = n[i];
                index = i;
            }
        }
        return new int[]{ans, index};
    }

    static void randFill(int[][] n, int bound) {
        Random r = new Random();
        for (int i = 0; i < n.length; i++) {
            for (int j = 0; j < n[0].length; j++) {
                n[i][j] = r.nextInt(bound);
            }
        }
    }

    static int[][] transpone(int[][] n) {
        int[][] newArray = new int[n[0].length][n.length];
        for (int i = 0; i < newArray.length; i++) {
            for (int j = 0; j < newArray[0].length; j++) {
                newArray[i][j] = n[j][i];
            }
        }
        return newArray;
    }

    static boolean check(int[] w, int[] mask, int n) {
        int ans = n;
        for (int i = 0; i < w.length; i++) {
            ans += w[i] * mask[i];
        }
        return ans == 0;
    }

    static void tasl1182(int n, int[] weights, int currentindex, int[] mask) {
        if (currentindex == weights.length) {
            if (check(weights, mask, n)) {
                boolean dsfgh = true;
                for (int i = 0; i < mask.length; i++) {
                    if (mask[i] == 1) {
                        System.out.print(weights[i] + " ");
                        dsfgh = false;
                    }
                }
                if (dsfgh) System.out.print(0);
                System.out.println();
                dsfgh = true;
                for (int i = 0; i < mask.length; i++) {
                    if (mask[i] == -1) {
                        System.out.print(weights[i] + " ");
                        dsfgh = false;
                    }
                }
                if (dsfgh) System.out.print(0);
                System.exit(0);
            }
            return;
        }
        tasl1182(n, weights, currentindex + 1, mask);
        mask[currentindex] = 1;
        tasl1182(n, weights, currentindex + 1, mask);
        mask[currentindex] = -1;
        tasl1182(n, weights, currentindex + 1, mask);
    }

    static String sec_to_standard(int n) {
        int sec = n % 60;
        n /= 60;
        int min = n % 60;
        n /= 60;
        int hour = n % 24;
        return String.format("%d:%2d:%2d", hour, min, sec).replace(" ", "0");
    }

    static int reverse(int n) {
        StringBuilder e = new StringBuilder(n + "");
        e.reverse();
        return Integer.parseInt(e.toString());
    }

    static int gcd(int a, int b) {
        if (a == 0) return b;
        if (b == 0) return a;
        return gcd(b, a % b);
    }

    static int MegaGCD(int[] n) {
        int ans = n[0];
        for (int i = 1; i < n.length; i++) {
            ans = gcd(ans, n[i]);
        }
        return ans;
    }

    static long factDivs(int n) {
        long ans = 1;
        int[][] div = {{2, 3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37, 41, 43},
                {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}};
        for (int i = 2; i <= n; i++) {
            int h = i;
            for (int j = 0; j < 14; j++) {
                while (h % div[0][j] == 0) {
                    h /= div[0][j];
                    div[1][j]++;
                }
            }
        }
        for (int i = 0; i < 14; i++) {
            ans *= div[1][i] + 1;
        }
        return ans;
    }

    static boolean[] save;

    static void rucksack(int maxw, int curp, int[] vals, int ind) {
        if (save[ind]) return;
        if (maxw == curp) {
            System.out.println("YES");
            System.exit(0);
        } else if (ind == vals.length) {
            return;
        }
//        if (ind == vals.length) {
//            save[] = true;
//        }
        if (maxw >= curp + vals[ind]) rucksack(maxw, curp + vals[ind], vals, ind + 1);
        rucksack(maxw, curp, vals, ind + 1);
        save[ind] = true;
    }

    static void Magic() {
        Scanner s = new Scanner(System.in);
        int n = s.nextInt();
        long[][] ts = new long[2 * n - 1][2 * n - 1];
        long[][] ans = new long[n][n];
        for (int i = 0; i < ts.length; i++) {
            for (int j = 0; j < ts[0].length; j++) {

            }
        }
        long offset = 0;
        for (int i = 0; i < n * n; i++) {
            if (n - 1 - i + offset < 0) offset += n;
            ts[(int) ((n - 1 - i) + offset + offset / n)][(int) (i % n + i / n)] = i + 1;
        }
        printMatrix(ts);
        System.out.println();
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                ans[i][j] = (ts[(n - 1) / 2 + i][(n - 1) / 2 + j] > 0 ? ts[(n - 1) / 2 + i][(n - 1) / 2 + j] : ts[2 * n - 2 - ((n - 1) / 2 - (i + 1))][(n - 1) / 2 + j]);
                printMatrix(ans);
            }
        }
        printMatrix(ans);
    }

    static void printStack(LinkedList<Integer> st) {
        Object[] arr = st.toArray();
        for (int i = arr.length - 1; i >= 0; i--) {
            out.print(arr[i] + " ");
        }
//        for (int i = 0; i < arr.length; i++) {
//            System.out.print(arr[i] + " ");
//        }
    }

    static boolean isPrime(int n) {
        for (int i = 2; i < Math.floor(Math.sqrt(n)) + 1; i++) {
            if (n % i == 0) return false;
        }
        return true;
    }

    static BufferedWriter output;

    static void taskD(int n, int[] prev, int ind) throws IOException {
        if (n == 0) {
//            printArray(prev);
            for (int i = 0; i < prev.length; i++) {
                if (prev[i + 1] != 0) output.write(prev[i] + "+");
                else {
                    output.write(prev[i] + "\n");
                    break;
                }
            }
            output.flush();
//            output.write("\n");
        } else if (ind == 0) {
            int[] newPrev = prev.clone();
            for (int i = 1; i <= n / 2; i++) {
                newPrev[ind] = i;
                taskD(n - i, newPrev, ind + 1);
            }
            newPrev[ind] = n;
            taskD(0, newPrev, ind + 1);
        } else if (ind == 1) {
            int[] newPrev = prev.clone();
            for (int i = prev[0] + 1; i <= n; i++) {
                newPrev[ind] = i;
                taskD(n - i, newPrev, ind + 1);
            }
        } else if (ind > 1) {
            int[] newPrev = prev.clone();
            for (int i = prev[ind - 1] + 1; i <= n; i++) {
                if (prev[ind - 2] + i != 2 * prev[ind - 1]) {
                    newPrev[ind] = i;
                    taskD(n - i, newPrev, ind + 1);
                }
            }
        }
    }

    static ArrayList<Integer> ans = new ArrayList<>();

    static boolean check(int n, int k, int[] sq) {
        if (n == 0 && k != 1) return false;
        if (k == 1) {
            ans.add(n);
            return true;
        }
        for (int i = 0; i < sq.length; i++) {
            if (check(sq[i], k - 1, sq)) {
                ans.add(n - sq[i]);
                break;
            }
        }
        return true;
    }

    public static void main(String[] args) throws IOException {
        FastReader s = new FastReader();
        int n = s.nextInt();
        int k = s.nextInt();
        int[] sqs = new int[(int) Math.ceil(Math.sqrt(n))];
        for (int i = 0; i < sqs.length; i++) {
            sqs[i] = (i + 1) * (i + 1);
        }
        if (check(n, k, sqs)) {
            System.out.println("YES");
            for (int i = 0; i < ans.size(); i++) {
                System.out.print(ans.get(i) + " ");
            }
        } else System.out.println("NO");
    }
}

class FastReader {
    BufferedReader br;
    StringTokenizer st;

    public FastReader() {
        br = new BufferedReader(
                new InputStreamReader(System.in));
    }

    String next() {
        while (st == null || !st.hasMoreElements()) {
            try {
                st = new StringTokenizer(br.readLine());
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
        return st.nextToken();
    }

    int nextInt() {
        return Integer.parseInt(next());
    }

    long nextLong() {
        return Long.parseLong(next());
    }

    double nextDouble() {
        return Double.parseDouble(next());
    }

    String nextLine() {
        String str = "";
        try {
            if (st.hasMoreTokens()) {
                str = st.nextToken("\n");
            } else {
                str = br.readLine();
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
        return str;
    }
}
//class Stac<T> {
//    T[] n;
//    int top;
//
//    public Stac(int size) {
//        n = (T[]) new Object[size];
//        top = 0;
//    }
//
//    void push(T t) {
//        if (isFull()) {
//            System.out.println("StackOverflowError");
//            System.exit(1);
//        }
//        n[++top] = t;
//    }
//
//    T pop() {
//        if (isEmpty()) {
//            System.out.println("StackUnderflowError");
//            System.exit(1);
//        }
//        return n[top--];
//    }
//
//    boolean isEmpty() {
//        return top <= 0;
//    }
//
//    boolean isFull() {
//        return top == n.length - 1;
//    }
//
//    T readTop() {
//        if (isEmpty()) {
//            System.out.println("QueueUnderflowError");
//            System.exit(1);
//        }
//        return n[top];
//    }
//
//    void clear() {
//        top = -1;
//    }
//}
//
//class Que<T> {
//    int rear;
//    int front;
//    int len;
//    T[] n;
//
//    public Que(int size) {
//        n = (T[]) new Object[size];
//        front = 0;
//        rear = -1;
//        len = 0;
//    }
//
//    void push(T t) {
//        if (isFull()) {
//            System.out.println("QueueOverflowError");
//            System.exit(1);
//        }
//        if (rear == n.length - 1) rear = -1;
//        len++;
//        n[++rear] = t;
//    }
//
//    T pop() {
//        if (isEmpty()) {
//            System.out.println("QueueUnderflowError");
//            System.exit(1);
//        }
//        T poped = n[front];
//        if (front == n.length - 1) front = -1;
//        len--;
//        front++;
//        return poped;
//    }
//
//    boolean isEmpty() {
//        return len == 0;
//    }
//
//    boolean isFull() {
//        return len == n.length;
//    }
//
//    T readTop() {
//        if (isEmpty()) {
//            System.out.println("QueueUnderflowError");
//            System.exit(1);
//        }
//        return n[front];
//    }
//
//    T readBottom() {
//        if (isEmpty()) {
//            System.out.println("QueueUnderflowError");
//            System.exit(1);
//        }
//        return n[rear];
//    }
//
//    void clear() {
//        front = 0;
//        rear = -1;
//        len = 0;
//    }
//
//    int length() {
//        return len;
//    }
//}
//
//class Deq<T> {
//    int rear;
//    int front;
//    int len;
//    T[] n;
//
//    public Deq(int size) {
//        n = (T[]) new Object[size];
//        front = 0;
//        rear = -1;
//        len = 0;
//    }
//
//    void push_back(T t) {
//        if (isFull()) {
//            System.out.println("QueueOverflowError");
//            System.exit(1);
//        }
//        if (rear == n.length - 1) rear = -1;
//        len++;
//        n[++rear] = t;
//    }
//
//    void push_front(T t) {
//        if (isFull()) {
//            System.out.println("QueueOverflowError");
//            System.exit(1);
//        }
//        if (front == 0) front = n.length;
//        len++;
//        n[--front] = t;
//    }
//
//    T pop_front() {
//        if (isEmpty()) {
//            System.out.println("QueueUnderflowError");
//            System.exit(1);
//        }
//        T poped = n[front];
//        if (front == n.length - 1) front = -1;
//        len--;
//        front++;
//        return poped;
//    }
//
//    T pop_back() {
//        if (isEmpty()) {
//            System.out.println("QueueUnderflowError");
//            System.exit(1);
//        }
//        T poped = n[rear];
//        if (rear == 0) rear = n.length;
//        len--;
//        rear--;
//        return poped;
//    }
//
//    boolean isEmpty() {
//        return len == 0;
//    }
//
//    boolean isFull() {
//        return len == n.length;
//    }
//
//    T readTop() {
//        if (isEmpty()) {
//            System.out.println("QueueUnderflowError");
//            System.exit(1);
//        }
//        return n[front];
//    }
//
//    T readBottom() {
//        if (isEmpty()) {
//            System.out.println("QueueUnderflowError");
//            System.exit(1);
//        }
//        return n[rear];
//    }
//
//    void clear() {
//        front = 0;
//        rear = -1;
//        len = 0;
//    }
//
//    int length() {
//        return len;
//    }
//}
