#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <stack>
#include <unordered_set>
#include <string>
#include <cmath>
#include <random>
#include <climits>
#include <queue>


using namespace std;
typedef long long ll;

const int INF = 1e9;
const int MOD = 1e9 + 1;

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);

    int k, w, h, t;
    cin >> k >> w >> h >> t;
    int border = 0;
    for (int i = 0; i < h; ++i) {
            for (int g = 0; g < k + 2*t; ++g) {
                for (int l = 0; l < k * w + (w + 1) * t; ++l) {
                    if (g >= 0 && g < t || g > k + t - 1){
                        cout << "*";
                    }
                    else if (l >= border + t && l < k + t + border) {
                        cout << ".";
                        if (l == t + k + border - 1) {
                            border += t + k;
                        }
                    }
                    else {
                        cout << "*";
                    }
                }
                cout << endl;
                border = 0;
            }
    }

    return 0;
}


