#include <iostream>
#include <unordered_set>
#include <cmath>
#include <vector>

using namespace std;
// #define int long long
 
#ifdef FILE_WORK
    #include <fstream>
    ifstream in("build_project/input.txt");
    ofstream out("build_project/output.txt");
    #define cin in
    #define cout out
#endif

unordered_set<int> sss(35);
vector<bool> good(200000, true);

bool split(int n, int k, int s) {
    if (n < 0) return false;
    int a = sqrt(n);
    if (k == 1) {
        if (a * a == n && n < s && sss.count(a) == 0) {
            cout << "YES\n" << s - n<<" ";
            return true;
        }
        else {
			good[n] = false;
            return false;
        }
    }
    for (int i = 1; i * i < s; ++i) {
		if (sss.count(i) == 1) {
			continue;
		}
		sss.insert(i);
        if (split(n-i*i, k-1, s)) {
            cout << s- i * i << " ";
            return true;
        }
		sss.erase(i);
    }
    return false;
}
 
 
signed main() {
    int n, k; cin >> n >> k;
    if (!split(n * (k - 1), k, n)) {
        cout << "NO";
    }
    return 0;
}