import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.StringTokenizer;

public class F_SqrGen {
	public static void main(String[] args) throws IOException{
		BufferedReader br  =new BufferedReader(new InputStreamReader(System.in));
		StringTokenizer st = new StringTokenizer(br.readLine());
		int n = Integer.parseInt(st.nextToken());
		int k = Integer.parseInt(st.nextToken());
		
		int sqrt = (int) Math.sqrt(n);
		if(sqrt < k) {
			System.out.println("NO");
			System.exit(0);
		}
		int[] sqarr = new int[sqrt];
		for(int i = 0; i < sqrt; i++) {
			sqarr[i] = (i + 1) * (i + 1);
		}
		for(int i = 0; i < sqrt; i++) {
			for(int j = 0; j < sqrt; j++) {
				if(sqarr[i] + sqarr[j] == n) {
					System.out.println("YES");
					System.out.println((i+1) + " " + (j+1));
					System.exit(0);
				}
			}
		}
		System.out.println("NO");
	}
}
