#include <bits/stdc++.h>
using namespace std;

// 
// n - x1 + x2 = a1^2
// n - x2 + x3 = a2^2
// n - x3 + x4 = a3^2
// n - x4 + x5 = a4^2
// ...
// n - xk + x1 = ak^2
//
// k * n = a1^2 + a2^2 + ... + ak^2

int n, k;

void gen(int sum, int min, vector<int> &sqr) {
  if (sqr.size() != k) {
    if (sum <= 0) return;
    for (int i = min; i * i <= n; i++) {
      sqr.push_back(i);
      gen(sum - i * i, i+1, sqr);
      sqr.pop_back();
    }
  } else if (sum == 0) {
    vector<int> r(k);
    for (int i = 0; i < k; i++) {
      r[i] = n - sqr[i] * sqr[i];
      if (r[i] <= 0) return;
    }
    cout << "YES\n";
    for (int i = 0; i < k; i++) {
      cout << r[i] << ' ';
    }
    cout << '\n';
    exit(0);
  }
}

int main () {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  cout.tie(NULL);
  int minn = 1;
  cin >> n >> k;
  for (int i = 1; k-1 > i * i; i++) minn = i+1;
  
  vector<int> sqr;
  gen((k - 1) * n, minn, sqr);
  cout << "NO\n";
  return 0;
}
