#include <iostream>
#include <vector>
using namespace std;

int main() {
    int n, k;
    cin >> n >> k;

    vector<int> a(n);
    for (int i = 0; i < n; i++)
        cin >> a[i];

    vector<int> prefix_sum(n);
    prefix_sum[0] = a[0];
    for (int i = 1; i < n; i++) prefix_sum[i] = prefix_sum[i - 1] + a[i];

    int cnt = 0;
    for (int l = 0; l < n; l++) {
        for (int r = l; r < n; r++) {
            if ((prefix_sum[r] - ((l != 0) ? prefix_sum[l - 1] : 0)) % k == 0) {
                cnt++;
            }
        }
    }

    cout << cnt << endl;
}
