#include <iostream>
#include <vector>
using namespace std;

int main() {
    long long n, k;
    cin >> n >> k;

    vector<long long> a(n);
    for (int i = 0; i < n; i++)
        cin >> a[i];

    vector<long long> prefix_sum(n);
    prefix_sum[0] = a[0] % k;
    for (int i = 1; i < n; i++) prefix_sum[i] = (prefix_sum[i - 1] + a[i]) % k;

    long long cnt = 0;
    for (int l = 0; l < n; l++) {
        for (int r = l; r < n; r++) {
            long long s;
            if (l == 0) s = prefix_sum[r];
            else s = prefix_sum[r] - prefix_sum[l - 1];
            if (s % k == 0) {
                cnt++;
            }
        }
    }

    cout << cnt << endl;
}
