from math import ceil, gcd

 
def check(N):
    if N == 1 or N == 2 or N == 3:
        return True
    for n in range(2, ceil(N**0.5) + 1):
        if N % n == 0:
            return False
    return True
 
 
def sol(x, l, r):
    res = []
    for n in range(l, r + 1):
        if check(gcd(x, n)):
            if x != n:
                res += [n]
    return res
 
 
x = int(input())
l = int(input())
r = int(input())
# x = 18
# l = 1
# r = 15
 
res = sol(x, l, r)
print(len(res))
if res:
    print(" ".join(map(str, sorted(res))))