#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
using namespace std;



vector<int> check(vector<int>& a, vector<int>& b)
{
	sort(a.begin(), a.end());
	sort(b.begin(), b.end());

	vector<int> c;
	int ii = 0, jj = 0;
	for (int i = 0; i < a.size() + b.size(); i++)
	{
		if (ii < a.size() && jj < b.size() && a[ii] <= b[jj])
		{
			c.push_back(a[ii]);
			ii++;
			continue;
		}
		if (ii < a.size() && jj < b.size() && a[ii] > b[jj])
		{
			c.push_back(b[jj]);
			jj++;
			continue;
		}
		if(ii < a.size())
		{
			c.push_back(a[ii]);
			ii++;
			continue;
		}
		if (jj < b.size())
		{
			c.push_back(b[jj]);
			jj++;
			continue;
		}
	}

	for (int i = 1; i < c.size(); i++)
	{
		if (c[i] == c[i - 1]) return {0};
		if (i < c.size() - 1 && c[i] == (c[i - 1] + c[i + 1]) / 2) return {0};
	}
	return c;
}


vector<vector<int>> rick(int n)
{
	if (n == 1 || n == 2)
	{
		return { {n} };
	}
	vector<vector<int>> a(1, {n});
	for (int i = 1; i <= n / 2 - (1 - (n % 2)); i++)
	{
		int j = n - i;
		vector<vector<int>> b = rick(i), c = rick(j);
		for (int ii = 0; ii < b.size(); ii++)
		{
			for (int jj = 0; jj < c.size(); jj++)
			{
				vector<int> var = check(b[ii], c[jj]);
				if (var.size() > 1) a.push_back(var);
			}
		}
	}
	return a;
}


int main()
{
	int n;
	cin >> n;
	vector<vector<int>> a = rick(n);
	for (int i = 0; i < a.size(); i++)
	{
		bool h = false;
		for (int j = 0; j < i; j++)
		{
			if (a[i] == a[j]) h = true;
		}
		if (h) continue;
		for (int j = 0; j < a[i].size(); j++)
		{
			if (j > 0) cout << '+';
			cout << a[i][j];
		}
		cout << endl;
	}
}