#include<iostream>
#include<vector>
#include<algorithm>

using namespace std;

long long gcd(long long a,long long b)
{
	if(b==0) return a;
	if(a==0) return b;
	if(a < b) return gcd(a, b%a);
	return gcd(b, a%b);
}
long long is_prime(long long k)
{
	if(k==1) return 1;
	long long ans=1;
	for (long long j=2;j*j<=k;j++)
	{
		if(k%j==0) ans=0;
	}
	return ans;
}
long long check(long long a, long long b)
{
	long long t=gcd(a,b);
	return is_prime(t);
}
int main(void)
{
	long long n,k,l, ans=0;
	cin  >> n >> k;
	vector<long long > a(n+1);
	a[0]=0;
	for(long long i=0;i<n;i++) 
	{
		cin >> l;
		a[i+1]=(a[i]+l)%k;
	}
	sort(a.begin(), a.end());
	
	l=1;
	for(long long j=1;j<n+1;j++)
	{
		if(a[j]==a[j-1]) l++;
		else 
		{
			ans=ans+l*(l-1)/2;
			l=1;
		}
	}
	ans+=l*(l-1)/2;
	cout << ans << endl; 
	
}
