#include <iostream>
#include <vector>
#include <cmath>

std::vector<int> recurs(int n, int k, int last, int rn) {
    if(k == 1) {
        int t = sqrt(n);
        if(t * t == n && t > last && t * t <= rn) return {t};
        else return {-1};
    }
    int t = sqrt(std::min(n, rn));
    if(t + 1 < k + last) return {-1};
    int sum = 0;
    for(int i = t;i > t - k;i--) sum += i * i;
    if(sum < n) return {-1};
    for(int i = last + 1;i * i < std::min(n, rn);++i) {
        //std::cout << i << " " << i * i << " " << n << std::endl;
        std::vector<int> a = recurs(n - i * i, k - 1, i, rn);
        if(a.size() > 0 && a[0] > 0) {
            a.push_back(i);
            return a;
        }
    }
    return {-1};
}

int main() {
    int n, k;
    std::cin >> n >> k;
    int t = n * (k - 1);
    std::vector<int> a = recurs(t, k, 0, n);
    //for(int i : a) std::cout << i << " ";
    //std::cout << std::endl;
    if(a.size() == k) {
        std::vector<int> ans;
        for(int i : a) ans.push_back(n - i * i);
        std::cout << "YES\n";
        for(int i : ans) std::cout << i << " ";
    }
    else std::cout << "NO";
}
