﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <map>
#include <unordered_map>

using namespace std;

int main()
{
    long long n, k;
    cin >> n >> k;

    vector<long long> pr(n+1);
    unordered_map<long long, long long> mp;
    ++mp[0];

    for (int i = 1; i < n+1; ++i)
    {
        int buf;
        cin >> buf;
        pr[i] = (pr[i - 1] + buf) % k;
        ++mp[pr[i]];
    }

    long long ans = 0;

    for (auto i : mp)
    {
        ans += (i.second * (i.second - 1)) / 2;
    }
    
    cout << ans;
    return 0;
}