#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>

using namespace std;

bool pohoshi(long long a, long long b)
{
    // a > b
    long long t = min(a,b);
    a = max(a,b);
    b = t;
    long long c = 0;
    if(a%b == 0)
    {
        c++;
    }
    for(int i = 1; i < sqrt(a); i++)
    {
        if(a%i == 0 && b%i == 0 && i != 1 && i != a && i != b)
        {
            //cout << i << " ";
            c++;
            long long da = a/i;
            long long db = b/i;
            if((a%da == 0 && b%da == 0) && da != i)
            {
                return false;
            }
            if((a%db == 0 && b%db == 0) && db != i)
            {
                return false;
            }
        }
        if(c >= 2)
        {
            return false;
        }
    }
    return true;
}
int main()
{
    long long x,y,l,r;
    vector<long long>answer;
    cin >> x >> l >> r;
    y = l;
    while(y <= r)
    {
        if(x != y)
        {
            if(pohoshi(x,y))
            {
                answer.push_back(y);
            }
        }
        y++;
    }
    cout << answer.size() << endl;
    for(int i = 0; i < answer.size(); i++)
    {
        cout << answer[i] << " ";
    }
}
