#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>

using namespace std;

bool nepohoshi(long long a, long long b)
{
    // a > b
    long long t = min(a,b);
    a = max(a,b);
    b = t;
    long long c = 0;
    if(a%b == 0)
    {
        c++;
    }
    for(int i = 1; i <= sqrt(a); i++)
    {
        if(a%i == 0 && b%i == 0 && i != 1 && i != a && i != b)
        {
            c++;
        }
        long long da = a/i;
        long long db = b/i;
        //cout << i << "  ---->  " << da << " " << db << endl;
        if((a%da == 0 && b%da == 0) && da != i)
        {
            c++;
        }
        if((a%db == 0 && b%db == 0) && db != i)
        {
            c++;
        }
        if(c >= 2)
        {
            return false;
        }
    }
    return true;
}

bool nepohoshi2(long long a, long long b)
{
    long long c = 0;
    if(max(a,b)%min(a,b) == 0)
    {
        c++;
    }
    for(int i = 2; i <= (min(a,b)+min(a,b)%2)/2; i++)
    {
        if(a%i == 0 && b%i == 0)
        {
            c++;
        }
        if(c >= 2)
        {
            return false;
        }
    }
    return true;
}
int main()
{
    /*
    for(int xi = 1; xi < 100; xi++)
    {
        for(int yi = 1; yi < 100; yi++)
        {
            if(nepohoshi2(xi,yi) != nepohoshi(xi,yi) && xi != yi)
            {
                cout << "Error: " << xi << " " << yi << endl;
                cout << "Nado: " << nepohoshi2(xi,yi) << endl;
                cout << "Est: " << nepohoshi(xi,yi) << endl;
            }
        }
    }
    */
    long long x,y,l,r;
    vector<long long>answer;
    cin >> x >> l >> r;
    y = l;
    while(y <= r)
    {
        if(x != y)
        {
            if(nepohoshi(x,y))
            {
                answer.push_back(y);
            }
        }
        y++;
    }
    cout << answer.size() << endl;
    for(int i = 0; i < answer.size(); i++)
    {
        cout << answer[i] << " ";
    }
}
