﻿// F.cpp : Этот файл содержит функцию "main". Здесь начинается и заканчивается выполнение программы.
//

#include <iostream>
#include <vector>
#include <set>
using namespace std;

vector<int> vec;
int n, k;
vector<int> sqr; 
int summ = 0;

bool inSqr(int x) {
    int l = 0, r = sqr.size();
    while (r - l > 1) {
        int m = (l + r) / 2;
        if (sqr[m] <= x) {
            l = m;
        }
        else {
            r = m;
        }
    }
    return sqr[l] == x;
}

bool check() {
    for (auto& elem : vec) {
        if (!inSqr(summ - elem)) {
            return false;
        }
    }
    return true;
}

bool gen(int i) {
    if (vec.size() > k) {
        return false;
    }
    if (summ > n) {
        return false;
    }
    if (summ == n) {
        if (check) {
            cout << "YES\n";
            for (auto& elem : vec) {
                cout << elem << ' ';
            }
            cout << '\n';
            return true;
        }
        return false;
    }
    vec.push_back(i-1);
    while (summ + i <= n) {
        summ += i;
        vec[vec.size() - 1]++;
        if (gen(i + 1)) {
            return true;
        }
        summ -= i;
        i++;
    }
    vec.pop_back();
    return false;
}

int main()
{
    cout.setf(ios::fixed);
    cout.precision(20);
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> n >> k;
    int i = 1;
    while (i * i <= n) {
        sqr.push_back(i * i);
        ++i;
    }

    if (!gen(1)) {
        cout << "NO\n";
    }
    return 0;
}

// Запуск программы: CTRL+F5 или меню "Отладка" > "Запуск без отладки"
// Отладка программы: F5 или меню "Отладка" > "Запустить отладку"

// Советы по началу работы 
//   1. В окне обозревателя решений можно добавлять файлы и управлять ими.
//   2. В окне Team Explorer можно подключиться к системе управления версиями.
//   3. В окне "Выходные данные" можно просматривать выходные данные сборки и другие сообщения.
//   4. В окне "Список ошибок" можно просматривать ошибки.
//   5. Последовательно выберите пункты меню "Проект" > "Добавить новый элемент", чтобы создать файлы кода, или "Проект" > "Добавить существующий элемент", чтобы добавить в проект существующие файлы кода.
//   6. Чтобы снова открыть этот проект позже, выберите пункты меню "Файл" > "Открыть" > "Проект" и выберите SLN-файл.
