#include<bits/stdc++.h>
using namespace std;

using ll = long long;
#define all(x) (x).begin(), (x).end()

template<typename T>
istream& operator>>(istream& in, vector<T>& arr) {
    for (int i = 0; i < arr.size(); ++i) {
        cin >> arr[i];
    }
    return in;
}
template<typename T>
ostream& operator<<(ostream& out, vector<T> arr) {
    for (int i = 0; i < arr.size(); ++i) {
        cout << arr[i];
        if (i != arr.size() - 1) cout << " ";
    }
    return out;
}

const int N = 3e5;
const int K = 31;

bool dp[K][N * K];
int p[K][N * K];

int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(0);
    cin.tie(0);
#endif

    int n, k;
    cin >> n >> k;
    for (int i = 0; i <= k; ++i) for (int j = 0; j <= n * (k - 1); ++j) dp[i][j] = 0;
    dp[0][0] = 1;
    for (int c = 1; c * c < n; ++c) {
        for (int i = k; i; --i) {
            for (int w = 0; w + c * c <= n * (k - 1); ++w) {
                if (!dp[i - 1][w]) continue;
                if (!dp[i][w + c * c]) {
                    dp[i][w + c * c] = 1;
                    p[i][w + c * c] = c;
                }
            }
        }
    }
    if (dp[k][n * (k - 1)]) {
        cout << "YES\n";
        vector<int> cur;
        int w = n * (k - 1);
        for (int i = k; i; --i) {
            cur.push_back(p[i][w]);
            w -= p[i][w] * p[i][w];
        }
        for (auto i : cur) cout << n - i * i << ' ';
    } else {
        cout << "NO";
    }
}