#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>

using namespace std;

bool isSimple(int a) {
    for (int i = 2; i * i <= a; i++) {
        if (a % i == 0) {
            return false;
        }
    }
    return true;
}

int gsd(long long a, long long b) {
    if (a == b) {
        return a;
    }
    else {
        if (b > a) {
            int tmp = a;
            a = b;
            b = tmp;
        }
        gsd(b,a-b);
    }
}

int main() {

    long long x, l, r;
    cin >> x >> l >> r;

    vector<long long> y;

    for (long long i = l; i <= r; i++) {
        if (x > i) {
            if (isSimple(gsd(x, i))) {
                y.push_back(i);
            }
        }
        else {
            if (isSimple(gsd(i, x))) {
                y.push_back(i);
            }
        }
    }

    cout << y.size() << "\n";
    for (int i = 0; i < y.size(); i++) {
        cout << y[i] << " ";
    }


    return 0;
}