﻿#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>

using namespace std;


int nod(int x, int y) {
    if ((long long)x * y == 0)
        return max(x, y);
    if (x < y)
        swap(x, y);
    return nod(y, x % y);
}

bool prime(int x) {
    if (x <= 2) { return true; }
    if (x % 2 == 0) { return false; }
    for (int i = 3; i <= min((int)(sqrt(x)+1),x-1); i += 2) {
        if (x % i == 0) return false;
    }
    return true;
}


int main()
{
    int x, l, r;
    cin >> x >> l >> r;
    vector<int>ans(1,0);
    for (int i = l; i <= r; ++i) {
        if (prime(nod(x, i))) {
            ans.push_back(i);
        }
    }
    cout << ans.size()-1 << endl;
    for (int i = 1; i < ans.size(); ++i) {
        cout << ans[i] << ' ';
    }
    if (ans.size() > 1)
        cout << endl;
}