#include <bits/stdc++.h>

#define int long long
#define x first
#define y second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define inf (INT64_MAX / 2)

using namespace std;

vector<vector<int>> dp;
int n, k, sqn;

void calc(int i, int j) {
    if (j == k - 1) {
        return;
    }
    int sq = sqrt(n * (k - 1) - i);
    for (int l = dp[i][j] + 1; l <= sq && l < sqn; l++) {
        if (dp[i + l * l][j + 1] == -1) {
            dp[i + l * l][j + 1] = l;
            calc(i + l * l, j + 1);
        }
    }
}

void solve() {
    cin >> n >> k;
    dp.resize(n * (k - 1) + 1, vector<int>(k, -1));
    sqn = sqrt(n);
    if (sqn * sqn < n) {
        sqn++;
    }
    for (int i = 1; i < sqn; i++) {
        dp[i * i][0] = i;
        calc(i * i, 0);
    }
    if (dp[n * (k - 1)][k - 1] == -1) {
        cout << "NO\n";
        return;
    }
    cout << "YES\n";
    int ind = n * (k - 1), jnd = k - 1;
    while (jnd >= 0) {
        cout << n - dp[ind][jnd] * dp[ind][jnd] << ' ';
        ind -= dp[ind][jnd] * dp[ind][jnd];
        jnd--;
    }
}

signed main() {
    //ios::sync_with_stdio(false);
    //cin.tie(nullptr); cout.tie(nullptr);
    cout << setprecision(128);
    int _ = 1;
    //cin >> _;
    while (_--) {
        solve();
    }
}
