#include <bits/stdc++.h>
using namespace std;

using ll = long long;

bool is_prime(int n) {
    for (int i = 2; i * i <= n; i++) {
        if (n % i == 0) return false;
    }
    return true;
}

int main() {

    ios::sync_with_stdio(false);
    cin.tie(0);

    ll n, k;
    cin >> n >> k;

    vector<ll> v(n);
    for (int i = 0; i < n; i++) cin >> v[i];

    map<ll, ll> m;
    m[0] = 1;
    ll sum = 0;
    for (int i = 0; i < n; i++) {
        sum += v[i];
        m[sum % k]++;
    }

    ll ans = 0;
    for (auto [x, y] : m) {
        ans += y * (y - 1) / 2;
    }

    cout << ans;

}