#include <bits/stdc++.h>

typedef long long ll;

using namespace std;

bool is_simple(ll a) {
    ll cnt = 0, A = a;
    for (ll i = 2; i <= A; ++i) {
        while (a % i == 0) {
            cnt++;
            a /= i;
        }
    }
    if (cnt <= 1) {
        return true;
    }
    return false;
}

ll gcd(ll a, ll b) {
    if (b == 0) {
        return a;
    }
    return gcd(b, a % b);
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll x, l, r;
    cin >> x >> l >> r;

    vector<ll> ans;
    for (ll i = l; i <= r; ++i) {
        if (is_simple(gcd(x, i))) {
            ans.push_back(i);
        }
    }
    cout << ans.size() << "\n";
    for (ll i : ans) {
        cout << i << " ";
    }
    return 0;
}
