#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>

typedef long long ll;

#define en '\n'

using namespace std;

bool check(ll x, ll y) {
	int count = 0;
	for (int i = 2; i <= min(x, y); i++) {
		if (x % i == 0 and y % i == 0) count++;
		if (count == 2) return false;
	}
	return true;
}

int main() {
	ll x, l, r;
	cin >> x >> l >> r;

	vector<int> ans;
	for (ll i = l; i <= r; i++) {
		if (check(x, i)) {
			ans.push_back(i);
		}
	}

	cout << ans.size() << en;
	for (ll y : ans) cout << y << " ";
	cout << en;
}