﻿#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>


using namespace std;

typedef long long int ll;

int main()
{
    ll x;
    cin >> x;
    ll l, r;
    cin >> l >> r;

    vector<ll> ans;

    for (ll i = l; i <= r; i++) {

        if (i != x) {

            ll a = i;
            ll b = x;
            while (a != 0 && b != 0) {
                if (a > b) {
                    a = a % b;
                }
                else {
                    b = b % a;
                }
            }
            ll res = a + b;

            bool good = true;

            for (ll k = 2; k < min(i, (ll)sqrt(res) + 1); k++) {
                if (res % k == 0) {
                    good = false;
                    break;
                }
            }

            if (good) {
                ans.push_back(i);
            }
        }
    }

    cout << ans.size() << "\n";
    for (int i = 0; i < ans.size(); i++) {
        cout << ans[i] << " ";
    }

}
