#include <iostream>
#include <fstream>
#include <vector>
#include <map>
#include <algorithm>
using namespace std;

int gcd (int a, int b) {
    if (b == 0) {
        return a;
    }
    else {
        return gcd (b, a % b);
    }
}

bool isPrime(int x) {
    for(long long i = 2; (long long) (i * i) <= x; i++) {
        if(x % i == 0) {
            return false;
        }
    }
    return true;
}

int main() {
    int x, l, r;
    cin >> x >> l >> r;
    
    int ans = 0;
    vector<int> v;
    for(int i = l; i <= r; i++) {
        if (isPrime(gcd(x, i))) {
            ans++;
            v.push_back(i);
        }
    }
    cout << ans << endl;
    for(auto i : v) {
        cout << i << " ";
    }
    cout << endl;
    return 0;
}
