from math import ceil, sqrt


def factors(n):
    result = []
    for i in range(2, ceil(sqrt(n) + 1)):
        if not n % i:
            result.append(i)
            result.append(n // i)
    return set(result)


def is_not_similar(a, b):
    return len(factors(a) & factors(b)) < 2


if __name__ == '__main__':
    x, l, r = [int(input()) for _ in range(3)]
    res = []
    for y in range(l, r+1):
        if is_not_similar(x, y):
            res.append(str(y))
    print(len(res))
    print(' '.join(res))




