#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <iomanip>
#include <bitset>
#include <queue>
#include <deque>
#include <unordered_map>
#include <random>
#include <chrono>
#include <cassert>
#include <type_traits>
#include <unordered_set>

#define debug(x) cerr << (#x) << ":\t" << (x) << endl;

#define fi first
#define se second

using namespace std;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

typedef long long ll;
typedef unsigned long long ull;

int solve();

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    solve();

    return 0;
}

int solve() {
    int k, w, h, t;
    cin >> k >> w >> h >> t;
    vector<vector<char>> a(k * h + (h + 1) * t,
                           vector<char> (k * w + (w + 1) * t, '.'));
    int num = 0;
    for (int i = 0; i < h + 1; i++) {
        for (int j = 0; j < t; j++) {
            for (char &c : a[num]) {
                c = '*';
            }
            num++;
        }
        num += k;
    }
    num = 0;
    for (int i = 0; i < w + 1; i++) {
        for (int j = 0; j < t; j++) {
            for (auto & c : a) {
                c[num] = '*';
            }
            num++;
        }
        num += k;
    }
    for (auto i : a) {
        for (auto j : i) {
            cout << j;
        }
        cout << endl;
    }
    return 0;
}
