/*#include <iostream>
#include <cmath>
#include <algorithm>

using namespace std;

void solve()
{
    int n, k;

    cin >> n >> k;

    int m = sqrt(n);

    if (k == 2)
    {
        for (int i = 1; i < m; i++)
        {
            for (int j = 1; j < m; j++)
            {
                if (i*i + j*j == n && i!=j) {
                    cout << "YES" << endl;
                    cout << i*i << " " << j*j;
                    return;
                }
            }
        }
        cout << "NO";
        return;
    }
    if (k == 3)
    {
        for (int i = 1; i < m; i++)
        {
            for (int j = 1; j < m; j++)
            {
                for (int l = 0; l < m; l++)
                {
                    if (i*i + j*j + l*l == n && i!=j && j!=l && i!=l)
                    {
                        cout << "YES" << endl;
                        cout << i << " " << j << " " << l;
                        return;
                    }
                }
            }
        }
        cout << "NO";
        return;
    }
}

int main() {
    int k = 1;
    // cin >> k;

    while(k != 0)
    {
        solve();
        k--;
    }
}*/



#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>

using namespace std;

int gcd(int a, int b)
{
    if (a > b) swap(a, b);

    while(a!=0)
    {
        b -= a;
        if (a > b) swap(a, b);
    }

    return b;
}

bool is_prime(int a)
{
    int q = sqrt(a);

    for (int i = 2; i <= q; i++)
    {
        if (a % i == 0) return false;
    }

    return true;
}

void solve()
{
    int x, l, r, gc;

    cin >> x >> l >> r;

    vector<int> ans;

    if (x == 1)
    {
        cout << 0;
        return;
    }

    for (int i = l; i <= r; i++)
    {
        gc = gcd(x, i);
        if (is_prime(gc)) ans.push_back(i);
    }

    cout << ans.size() << endl;

    for (int i = 0; i < ans.size(); i++)
    {
        cout << ans[i] << " ";
    }
}

int main() {
    int k = 1;
    // cin >> k;

    while(k != 0)
    {
        solve();
        k--;
    }
}