/*#include <iostream>
#include <cmath>
#include <algorithm>

using namespace std;

void solve()
{
    int n, k;

    cin >> n >> k;

    int m = sqrt(n);

    if (k == 2)
    {
        for (int i = 1; i < m; i++)
        {
            for (int j = 1; j < m; j++)
            {
                if (i*i + j*j == n && i!=j) {
                    cout << "YES" << endl;
                    cout << i*i << " " << j*j;
                    return;
                }
            }
        }
        cout << "NO";
        return;
    }
    if (k == 3)
    {
        for (int i = 1; i < m; i++)
        {
            for (int j = 1; j < m; j++)
            {
                for (int l = 0; l < m; l++)
                {
                    if (i*i + j*j + l*l == n && i!=j && j!=l && i!=l)
                    {
                        cout << "YES" << endl;
                        cout << i << " " << j << " " << l;
                        return;
                    }
                }
            }
        }
        cout << "NO";
        return;
    }
}

int main() {
    int k = 1;
    // cin >> k;

    while(k != 0)
    {
        solve();
        k--;
    }
}*/



#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>

using namespace std;

int gcd(int a, int b)
{
    if (a > b) swap(a, b);

    while(a!=0)
    {
        b -= a;
        if (a > b) swap(a, b);
    }

    return b;
}

bool is_prime(int a)
{
    int q = sqrt(a);

    for (int i = 2; i <= q; i++)
    {
        if (a % i == 0) return false;
    }

    return true;
}

void solve()
{
    int n, k, t, ans = 0;

    cin >> n >> k;

    vector<int> a(n + 1);

    a[0] = 0;

    for (int i = 1; i <= n; i++)
    {
        cin >> t;
        a[i] = t % k + a[i-1];
    }

    for (int i = 1; i <= n; i++)
    {
        for (int j = i; j <= n; j++)
            if ((a[j] - a[j - i]) % k == 0) ans++;
    }

    cout << ans;
}

int main() {
    int k = 1;
    // cin >> k;

    while(k != 0)
    {
        solve();
        k--;
    }
}