#include <iostream>

void draw_line_hor( int w, int t, int k )
{
	for (int i = 0; i < w * k + (w + 1) * t; i++)
		std::cout << '*';
	std::cout << std::endl;
}

void draw_line_hor_with_cell( int width, int t, int k, int w )
{
	for (int i = 0; i < width; i++)
	{
		if (i % 2 == 0)
			for (int j = 0; j < t; j++)
				std::cout << '*';
		else
			for (int j = 0; j < k; j++)
				std::cout << ' ';
	}
	std::cout << std::endl;
}

int main( void )
{
	int k, w, h, t;

	std::cin >> k;
	std::cin >> w;
	std::cin >> h;
	std::cin >> t;

	int 
		width = w * 2 + 1, 
		height = h * 2 + 1;

	for (int i = 0; i < height; i++)
		if (i % 2 == 0)
			for (int j = 0; j < t; j++)
			  draw_line_hor(w, t, k);
		else
			for (int j = 0; j < k; j++)
			  draw_line_hor_with_cell(width, t, k, w);

	return 0;
}