#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <map>

using namespace std;

#define int long long
#define VI vector<int>
#define VC vector<char>
#define VVI vector<VI>
#define VVC vector<VC>
#define endl '\n'

int gcd(int a,int b){
    if(!b) return a;
    return gcd(b,a%b);
}

int is_prime(int a){
    for(int i=2;i*i<=a;++i){
        if(a%i==0) return 0;
    }
    return 1;
}

VVI ans;

void rec(int dif,const VI& pred, int ost){
    if(!ost){ ans.push_back(pred);
        return;
    }
    for(int i=1;i<=ost;++i){
        if(pred.empty()||(i>pred[pred.size()-1]&&i-pred[pred.size()-1]!=dif)){
            VI np=pred;
            np.push_back(i);
            if(!pred.empty())rec(i-pred[pred.size()-1],np,ost-i);
            else rec(dif,np,ost-i);
        }
    }
}

VI pref(const VI& a){
    int n=a.size();
    VI res(n+1);
    res[0]=0;
    for(int i=1;i<n+1;++i){
        res[i]=a[i-1]+res[i-1];
    }
    return res;
}

signed main() {
    int n,k;
    cin>>n>>k;
    VI a(n);
    for(int& i:a){
        cin>>i;
    }
    map<int,int> m;
    VI p=pref(a);
    for(int i:p){
        i%=k;
        m[i]++;
    }
    int res=0;
    for(auto i:m){
        res+=(i.second*(i.second-1))/2;
    }
    cout<<res<<endl;
    return 0;
}