#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <math.h>
#include <bitset>
#include <string>

#define x first
#define y second
#define all(x) (x).begin(), (x).end()

#define ll long long
#define ld long double
#define endl '\n'

#define int ll

using namespace std;

void solve() {
    int n, k;
    cin >> n >> k;

    int inf = 1e9;

    vector<int> dp((k - 1) * n + 1, inf);

    dp[0] = 0;

    for (int i = 0; i < dp.size(); ++i) {
        if (dp[i] == inf)
            continue;

        for (int step = dp[i] + 1; step * step + i < dp.size(); ++step) {
            dp[i + step * step] = min(dp[i + step * step], step);
        }
    }

    int d = dp.back();

    if (d == inf) {
        cout << "NO" << endl;
    }
    else {
        cout << "YES" << endl;
        int cur = n * (k - 1);
        while (cur != 0) {
            cout << n * (k - 1) - dp[cur] * dp[cur] << " ";
            cur -= dp[cur] * dp[cur];
        }
    }
}

signed main()
{
    solve();

    return 0;
}