#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <string>
#include <set>
#include <fstream>
#include <numeric>

#define vi vector<ll>
#define pi pair<ll, ll>
#define forn(i, n) for (ll (i) = 0; (i) < (n); (i)++)
#define all(x) ((x).begin(), (x).end())

typedef long long ll;
typedef long double dbl;
using namespace std;

ll n;
vi save;
ll locs;
void gen(ll pos, ll curs, ll cnt) {
  if (curs == n) {
    for (int i = 0; i < cnt; i++) {
      cout << save[i];
      if (i != cnt - 1)
        cout << "+";
    }
    cout << '\n';           
  }
  for (int next = save[pos - 1] + 1; next <= n; next++) {
    save[pos] = next;
    ll f = 0;
    if (cnt >= 2) {
      locs = save[pos] + save[pos - 2]; 
      if (locs % 2 == 0 && save[pos - 1] == locs / 2)
        f = 1;
    }
    if (!f)
      gen(pos + 1, curs + next, cnt + 1);
  }
}

int main(void) {
  cin.tie(NULL);
  ios_base::sync_with_stdio(0);
  cin >> n;
  save.resize(n + 1);
  for (int i = 1; i <= n; i++) {
    save[0] = i;
    gen(1, i, 1);
  }
  return 0;
}

