#include <iostream>
#include <string>
#include <vector>
#include <cmath>

using namespace std;

typedef uint64_t ull;
typedef vector<ull> uv;
typedef vector<uv> uvv;
typedef pair<ull, ull> up;

vector<up> GetRazb(int n)
{
	vector<up> Res;
	int border = n / 2;
	if (n % 2 != 0)
		border++;

	for (int i = 1; i < border; i++)
		Res.push_back({ i, n - i });
	return Res;
}

int main(void)
{
	int n;

	cin >> n;
	for (auto& p : GetRazb(n))
		cout << p.first << "+" << p.second << endl;
	cout << n;
}