#include <iostream>
#include <string>
#include <vector>
#include <cmath>
#include <tuple>
#include <algorithm>

using namespace std;

typedef uint64_t ull;
typedef vector<ull> uv;
typedef pair<ull, ull> up;

int main(void)
{
	int n;
	ull k;
	uv Mas;

	cin >> n >> k;
	Mas.resize(n);
	for (auto& x : Mas)
		cin >> x;
	vector<uv> dyn(n);

	for (auto& m : dyn)
		m.resize(n);
	for (int i = 0; i < n; i++)
		dyn[i][i] = Mas[i];

	for (int i = 0; i < n; i++)
		for (int j = i + 1; j < n; j++)
		{
			if (i >= j)
				continue;
			dyn[i][j] = dyn[i][j - 1] + Mas[j];
		}

	ull cnt = 0;
	for (auto &m : dyn)
		for (auto &el : m)
			if (el != 0 && el % k == 0)
				cnt++;
	cout << cnt;
}