#include <iostream>
#include <vector>

uint64_t min(uint64_t a, uint64_t b)
{
    return a > b ? b : a;
}

bool IsMoreThanOneBothDel(uint64_t x, uint64_t y)
{
    int s = 0;

    if (y == 1)
        return false;

    uint64_t a = min(x, y);

    if (x % 2 == 0 && y % 2 == 0)
    {
        for (uint64_t i = 3; i <= a; i++)
            if (x % i == 0 && y % i == 0)
                return true;
    }
    else
    {
        for (uint64_t i = 3; i <= a; i += 2)
            if (x % i == 0 && y % i == 0)
            {
                s++;
                if (s > 1)
                    return true;
            }
    }

    return false;
}

int main()
{
    /*int k, w, h, t;


    std::cin >> k >> w >> h >> t;

    for (int i = 0; i < w; i++)
        for (int j = 0; j < h; j++)
            */

    uint64_t x, l, r;

    std::cin >> x >> l >> r;

    if (l == r)
        if (l == x || IsMoreThanOneBothDel(x, l))
        {
            std::cout << 0;
            return 0;
        }
        else
        {
            std::cout << 1 << std::endl << l;
            return 0;
        }
      

    std::vector<uint64_t> Res;

    for (uint64_t i = l; i <= r; i++)
        if (i != x && !IsMoreThanOneBothDel(x, i))
            Res.push_back(i);

    std::cout << Res.size() << std::endl;

    for (uint64_t i = 0; i < Res.size(); i++)
        std::cout << Res[i] << " ";

    return 0;
}