#include <iostream>
#include <vector>
#include <map>


#define ll long long
using namespace std;

int n;

bool iscor(vector<int> &a) {
  if (a.size() < 3) return 1;

  //int b = (a[0] + a.back()) * 3;

  for (int i = 0; i < a.size() - 2;i++) {
    if (a[i + 1] * 2 == a[i] + a[i + 2]) return 0;
  }
  return 1;
}

void gen(vector<int> &a, int sm) {
  if (sm == n && iscor(a)) {
    for (int i = 0; i < a.size() -1;i++) cout << a[i] << '+';
    cout << a.back();
    cout << "\n";
    return;
  }
  if (a.empty()) {
    for (int i = 1; i <= n;i++) {
      a.push_back(i);
      gen(a, sm + i);
      a.pop_back();
    }
  }
  else {
    for (int i = a.back() + 1; i <= n - sm;i++) {
      a.push_back(i);
      gen(a, sm + i);
      a.pop_back();
    }
  }

}

bool issqrt(int x) {
  int l = 1, r = x, m;

  while (r - l > 1) {
    m = (l + r) / 2;
    if (m * 1ll * m > x) {
      r = m;
    }
    else l = m;
  }
  return l * 1ll * l == x;
}

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);

  int n, k;

  cin >> n >> k;
  vector<int> a;
  for (int i = 1; i < n;i++) {
    if (issqrt(n - i)) a.push_back(i);
  }

  int m = a.size();
  //for (int v : a)  cout << v << ' ';
  vector<vector<int>> dp(n + 1, vector<int> (k + 1, -1));

  dp[0][0] = 0;

  for (int i = 0; i < m;i++) {
    for (int h = k; h >= 1;h--) {
      for (int j = n - a[i];j >= 0;j--) {
        if (dp[j][h - 1] != -1) {
          dp[j + a[i]][h] = a[i];
        }
      }
    }
  }

  if (dp[n][k] == -1) cout << "NO";
  else {
    cout << "YES\n";
    for (int i = k; i > 0;i--) {
      cout << dp[n][i] << ' ';
      n -= dp[n][i];
    }
  }








  return 0;
}