#include <iostream>
#include <utility>
#include <set>
#include <cmath>
#include <numeric>
#include <vector>

using namespace std;
using ll = long long;

void solve2(int n, int k)
{
    int x, y;
    pair<int, int> res{-1, -1};
    
    for (int x{1}; x < sqrt(n - 1); ++x)
    {
        for (int y{1}; y < sqrt(n - 1); ++y)
        {
            if (x^2 + y^2 == n && x != y)
            {
                res.first = x^2;
                res.second = y^2;
            }
        }
    }
    
    if (res.first == -1)
        cout << "NO" << '\n';
    else
    {
        cout << "YES" << '\n';
        cout << res.first << ' ' << res.second << '\n';
    }
}

int main()
{
    int n, k;
    cin >> n >> k;
    
    solve2(n, k);
}