import java.util.Arrays;
import java.util.Scanner;

public class E {
    private static int[] sublist(int[] arr, int beg, int end) {
        int[] res = new int[end - beg + 1];
        if (end + 1 - beg >= 0) System.arraycopy(arr, beg, res, 0, end + 1 - beg);
        return res;
    }

    private static int sum(int[] arr) {
        int res = 0;
        for (int value : arr)
            res += value;
        return res;
    }

    private static boolean dividesSub(int[] arr, int beg, int end, int k) {
        int[] a = sublist(arr, beg, end);
        return sum(a) % k == 0;
    }

    private static int countPairs(int[] arr, int k) {
        int res = 0;
        for (int i = 0; i < arr.length; i++) {
            for (int j = i; j < arr.length; j++) {
                if (dividesSub(arr, i, j, k))
                    res++;
            }
        }
        return res;
    }

    public static void main(String[] args) {
        Scanner s = new Scanner(System.in);
        int n = s.nextInt();
        int k = s.nextInt();
        int[] arr = new int[n];
        for (int i = 0; i < n; i++)
            arr[i] = s.nextInt();
        System.out.println(countPairs(arr, k));
    }
}
