#include <bits/stdc++.h>

#define int long long
#define all(a) a.begin(), a.end()
#define pb push_back

using namespace std;

const int N = 200200, K = 31;

int dp[K][N];
int p[K][N];

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> sq;
    for (int i = 1; i * i <= n; i++) {
        sq.pb(i * i);
    }
    dp[0][0] = 1;
    for (int i = 1; i <= k; i++) {
        for (int j = 1; j <= n; j++) {
            for (int d = sq.size() - 1; d >= 0; d--) {
                int x = n - sq[d];
                if (x <= 0 || j - x < 0) {
                    continue;
                }
                if (dp[i - 1][j - x] == 1 && p[i - 1][j - x] < x) {
                    dp[i][j] = 1;
                    p[i][j] = x;
                    break;
                }
            }
        }
    }
    if (dp[k][n] == 0) {
        cout << "NO\n";
        return;
    }
    cout << "YES\n";
    vector<int> res;
    int i = k, j = n;
    while (i > 0) {
        res.pb(p[i][j]);
        j -= p[i][j];
        i--;
    }
    for (int i = 0; i < k; i++) {
        cout << res[i] << " ";
    }
    cout << '\n';
}

int32_t main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();

    return 0;
}
