from sys import exit


def main():
    n, k = map(int, input().split())
    full_squares = []
    diff = []
    i = 0
    while (i + 1) ** 2 < n:
        i += 1
        full_squares.append(i ** 2)
        diff.append(n - i ** 2)
    diff.sort()
    if k == 2:
        for num in full_squares:
            if n - num in full_squares and num != n - num:
                print('YES')
                print(num, n - num)
                exit()
        print('NO')
    elif k == 3:
        for i in range(len(diff)):
            for j in range(len(diff) - 1, -1, -1):
                L = i
                R = j + 1
                if R < L:
                    continue
                while R - L > 1:
                    mid = (R + L) // 2
                    if diff[mid] + diff[i] + diff[j] > n:
                        R = mid
                    else:
                        L = mid
                if diff[i] + diff[j] + diff[L] == n:
                    print('YES')
                    print(diff[i], diff[L], diff[j])
        print('NO')


if __name__ == '__main__':
    main()
