#include <iostream>
#include <vector>

using namespace std;

int max(int a, int b) {
	if (a - b > 0) return a;
	return b;
}

bool areNumbersRazlich(int x, int y) {
	if (x != y) {
		int countOfDels = 0;
		for (int n = 2; n < max(x, y); n++) {
			if (x % n == 0 && y % n == 0) countOfDels++;
			if (countOfDels >= 2) return false;
		}
		if (countOfDels < 2) return true;
		return false;
	}
	return false;
}

int main() {
	int x, l, r;
	cin >> x >> l >> r;
	vector<int> c;
	int count = 0;
	for (int number = l; number <= r; number++) {
		if (areNumbersRazlich(number, x)) { c.push_back(number); count++; }
	}
	cout << count << endl;
	for (int i = 0; i < c.size(); i++) {
		cout << c[i] << " ";
	}
	return 0;
}