/******************************************************************************

Welcome to GDB Online.
GDB online is an online compiler and debugger tool for C, C++, Python, Java, PHP, Ruby, Perl,
C#, OCaml, VB, Swift, Pascal, Fortran, Haskell, Objective-C, Assembly, HTML, CSS, JS, SQLite, Prolog.
Code, Compile, Run and Debug online from anywhere in world.

*******************************************************************************/
#include <iostream>
#include <vector>
using namespace std;

int gcd(int a, int b) {
    if (b == 0) return a;
    else return gcd(b, a%b);
}

int main()
{
    int x, l, r;
    cin >> x >> l >> r;
    vector<int> f;
    int q = x;
    for (int i = 2; i*i <= q; ++i) {
        if (q%i == 0){
            f.push_back(i);
        }
        while (q%i == 0) q /= i;
    }
    if (q > 1) f.push_back(q);
    f.push_back(1);
    vector<int> out;
    for (int i = l; i <= r; ++i) {
        if (i == x) continue;
        int g = gcd(x, i);
        for (int j = 0; j < f.size(); ++j) {
            if (g == f[j]) {
                out.push_back(i);
                break;
            }
        }
    }
    cout << out.size() << '\n';
    for (int elem: out) {
        cout << elem << ' ';
    }
}