#include <bits/stdc++.h>
using namespace std;
#define int long long

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n, k;
    cin >> n >> k;
    vector<int> a;
    for (int x = 1; x * x < n; ++x) {
        a.push_back(n - x * x);
    }
    reverse(a.begin(), a.end());
    /*for (int x : a) {
        cout << x << ' ';
    }
    cout << '\n';*/
    vector<vector<bool>> dp(k + 1, vector<bool>(n + 1));
    vector<vector<int>> prv(k + 1, vector<int>(n + 1));
    dp[0][0] = true;
    for (int x : a) {
        for (int i = k - 1; i >= 0; --i) {
            for (int j = n; j >= 0; --j) {
                if (dp[i][j] && j + x <= n) {
                    dp[i + 1][j + x] = true;
                    prv[i + 1][j + x] = j;
                }
            }
        }
    }
    /*for (int i = 0; i <= k; ++i) {
        for (int j = 0; j <= n; ++j) {
            cout << dp[i][j] << ' ';
        }
        cout << '\n';
    }*/
    if (!dp[k][n]) {
        cout << "NO\n";
        return 0;
    }
    int ti = k, tj = n;
    vector<int> ans;
    while (ti > 0) {
        ans.push_back(tj - prv[ti][tj]);
        tj = prv[ti][tj];
        --ti;
    }
    cout << "YES\n";
    reverse(ans.begin(), ans.end());
    for (int x : ans) {
        cout << x << ' ';
    }
    cout << '\n';
}

/*
100 2
5: YES
1 4
10: YES
1 9
13: YES
4 9
17: YES
1 16
20: YES
4 16
25: YES
9 16
26: YES
1 25
29: YES
4 25
34: YES
9 25
37: YES
1 36
40: YES
4 36
41: YES
16 25
45: YES
9 36
50: YES
1 49
52: YES
16 36
53: YES
4 49
58: YES
9 49
61: YES
25 36
65: YES
1 64
65: YES
16 49
68: YES
4 64
73: YES
9 64
74: YES
25 49
80: YES
16 64
82: YES
1 81
85: YES
4 81
85: YES
36 49
89: YES
25 64
90: YES
9 81
97: YES
16 81
100: YES
36 64
*/
