#include <iostream>
#include <set>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

bool isPrime(int x) {
    for (int i = 2; i * i <= x; i++)
        if (x % i == 0)
            return false;
    return true;
}

int gcd(int a, int b) {
    return (b == 0 ? a : gcd(b, a % b));
}

int main() {
    int x, l, r; cin >> x >> l >> r;
    int ans = 0;
    for (int i = l; i <= r; i++) {
        if (i != x && isPrime(gcd(i, x)))
            ans++;
    }
    cout << ans << "\n";
    for (int i = l; i <= r; i++) {
        if (i != x && isPrime(gcd(i, x)))
            cout << i << " ";
    }
}
