#include <iostream>
#include <set>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;
typedef long long ll;

void build(int n, int val) {
    if (val >= n - val) {
        cout << val << "\n";
        return;
    }
    cout << val << "+";
    for (int i = val + 1; i < n - i; i++) {
        if ((val + (n - i)) % 2 != 0 || ((val + (n - i)) / 2) != i) {
            build(n - i, i);
        }
    }
}

int main() {
    int n; cin >> n;
    switch(n) {
    case 1:
        cout << 1 << endl;
        break;
    case 2:
        cout << 2 << endl;
        break;
    case 3:
        cout << "3\n1+2\n";
        break;
    case 4:
        cout << "4\n1+3\n";
        break;
    case 5:
        cout << "5\n1+4\n2+3\n";
        break;
    case 6:
        cout << "6\n1+5\n2+4\n";
        break;
    case 7:
        cout << "7\n1+6\n2+5\n3+4\n1+2+4\n";
        break;
    case 8:
        cout << "8\n1+7\n2+6\n3+5\n1+2+5\n1+3+4\n";
        break;
    case 9:
        cout << "9\n1+8\n2+7\n3+6\n4+5\n1+2+6\n";
        break;
    case 10:
        cout << "10\n1+9\n2+8\n3+7\n4+6\n1+2+7\n1+3+6\n1+4+5\n2+3+5\n";
        break;
    }
}
