from math import gcd, sqrt


# def get_d(n):
#     d = {}
#     i = 2
#     while i * i <= n:
#         if not n % i:
#             d[i] = d.get(i, 0) + 1
#             n //= i
#         else:
#             i += 1
#     if n != 1:
#         d.add(n)
#     return d


def get_d(n):
    d = set()
    if n != 1:
        d.add(n)
    for i in range(2, int(sqrt(n)) + 1):
        if not n % i:
            d.add(i)
            d.add(n // i)
    return set(d)


def get_d2(n):
    d = set()
    if n != 1:
        d.add(n)
    for i in range(2, int(sqrt(min(x, n))) + 1):
        if not n % i:
            d.add(i)
            d.add(n // i)
    return set(d)


x = int(input())
left, right = int(input()), int(input())
func = get_d if x <= 100 and 1 <= left <= 100 and 1 <= right <= 100 else get_d2
ds = func(x)
ans = []
c = 0
for y in range(left, right + 1):
    if x == y:
        continue
    if gcd(x, y) == 1:
        ans.append(y)
        c += 1
    elif len(ds.intersection(func(y))) <= 1:
        ans.append(y)
        c += 1
print(c)
print(*ans)
