#from math import gcd, sqrt
from functools import lru_cache


def gcd(a, b):
    while b != 0:
        a, b = b, a % b
    return a


@lru_cache()
def get_d(n):
    d = set()
    if n != 1:
        d.add(n)
    for i in range(2, int(n ** 0.5) + 1):
        if not n % i:
            d.add(i)
            d.add(n // i)
    return set(d)


@lru_cache()
def get_d2(n):
    d = set()
    if n != 1:
        d.add(n)
    for i in range(2, int(min(x, n) ** 0.5) + 1):
        if not n % i:
            d.add(i)
            d.add(n // i)
    return set(d)


def check(y):
    global c
    if x == y:
        return
    if gcd(x, y) == 1:
        ans.append(y)
        c += 1
        return
    elif len(ds.intersection(func(y))) <= 1:
        ans.append(y)
        c += 1


x = int(input())
left, right = int(input()), int(input())
func = get_d if x <= 100 and 1 <= left <= 100 and 1 <= right <= 100 else get_d2
ds = func(x)
ans = []
c = 0
for y in range(left, right + 1):
    check(y)
print(c)
print(*ans)
