def grid(cell_side, cells_at_horizontal, cells_at_vertical, gap) -> str:
    if cells_at_vertical == 0 or cells_at_horizontal == 0:
        return ""

    grid_width = cells_at_horizontal * cell_side + gap * (cells_at_horizontal + 1)
    hr = (grid_width * "*" + "\n") * gap

    res = ""
    res += hr

    for cell_y in range(cells_at_vertical):
        for cell_x in range(cell_side):
            for _ in range(cells_at_horizontal):
                res += gap * "*"
                res += cell_side * "."
            res += gap * "*"
            res += "\n"
        if cell_y != cells_at_vertical - 1:
            res += hr
    res += hr

    return res


if __name__ == "__main__":
    print(grid(int(input()), int(input()), int(input()), int(input())))
