﻿#include <iostream>
#include <map>
#include <cmath>
#include <vector>

using namespace std;

map<int, bool> func(long long x) {
    map<int, bool> ans;
    for (int i = 1; i <= sqrt(x); i++) {
        if (x % i == 0) {
            ans[i] = 1;
            ans[x / i] = 1;
        }
    }
    return ans;
}

bool funcC(long long x, map<int,bool> a) {
    int cnt = 0;
    for (int i = 2; i <= sqrt(x); i++) {
        if (x % i == 0) {
            if (a[i] == 1)
                cnt++;
            if (a[x / i] == 1 && x/i != i)
                cnt++;
            if (cnt >= 2)
                return 0;
        }
    }
    if (a[x] == 1)
        cnt++;
    if (cnt >= 2)
        return 0;
    return 1;
}

int main()
{
    long long x, l, r;
    cin >> x >> l >> r;
    map<int, bool> d = func(x);
    vector<long long> ans = {};
    for (size_t i = l; i <= r; i++) {
        if (funcC(i, d) == 1) {
            //cout << i << ' ';
            ans.push_back(i);
        }
    }
    cout << ans.size() << endl;
    for (size_t i = 0; i < ans.size(); i++) {
        cout << ans[i] << ' ';
    }
    return 0;
}