from functools import lru_cache
from math import floor

def check(lst):
    if len(lst) <= 2:
        return True
    for i in range(1, len(lst) - 1):
        if (lst[i - 1] + lst[i + 1]) / 2 == lst[i]:
            return False
    return True


@lru_cache(None)
def func(n, alo=-1):
    if n == 1:
        return [[1]]
    res = []
    for k in range(n - 1, 0, -1):
        t = n - k
        if t > alo:
            for i in func(k, alo=t):
                ab = sorted([t] + i)
                if len(set(ab)) == len(ab) and check(ab):
                    res += [ab]
    return res


p = int(input())
x = func(p)

for i in range(2, p):
    t = p - i
    if t > i:
        x += [[i, t]]
        
x += [[p]]
for i in x:
    print("+".join(map(str, i)))