#include <stdio.h>
#include <math.h>

int max (int a, int b) {
    if (a>b) return a;
    return b;
}

int similarity (int x, int y, int l, int r) {
    int dividers[r];
    int k=0;
    dividers[0] = 0;
    if (y<100) {
        for (int i=1; i<=max(x,y)/2; i++) {
            dividers[i]=0;
            if (x%(i+1)==0&&y%(i+1)==0) dividers[i]=1;
            k += dividers[i];
            if (k==2) break;
        }
    }
    else {
        for (int i=1; i<=sqrt(y)+1; i++) {
            dividers[i]=0;
            if (x%(i+1)==0&&y%(i+1)==0) dividers[i]=1;
            k += dividers[i];
            if (k==2) break;
        }
    }
    if (k<2&&x!=y) return 1;
    return 0;
}

int main () {
    int x, l, r, n = 0;
    scanf("%d%d%d", &x, &l, &r);
    int numbers[r-l+1];
    if (l==r) {
        if (similarity(x, l, l, r)) printf("1\n%d", l);
        else printf("0");
        return 0;
    }
    for (int y=l; y<=r; y++) {
        numbers[y-l] = 0;
        if (y==x) continue;
        if (similarity(x, y, l, r)) {
            numbers[y-l] = 1;
            n++;
        }
    }
    printf("%d\n", n);
    for (int i=0; i<=r-l; i++) if (numbers[i]==1) printf("%d ", i+l);
    return 0;
}