#include <iostream>
#include <vector>

using namespace std;

int gcd(int a, int b) {
    if (b == 0) {
        return a;
    }
    return gcd(b, a % b);
}

int main()
{
    int x, l, r;
    cin >> x >> l >> r;
    if (x <= 100 && l <= 100 && r <= 100) {
        int ans = 0;
        vector<int> ch;
        for (int i = l; i <= r; i++) {
            if (i == x) {
                continue;
            }
            int d = gcd(i, x);
            int check = 1;
            for (int j = 2; j * j <= d; j++) {
                if (d % j == 0){
                    check = 0;
                    break;
                }
            }
            if (check) {
                ans++;
                ch.push_back(i);
            }
        }
        cout << ans << "\n";
        for (auto i : ch) {
            cout << i << " ";
        }
        cout << "\n";
        return 0;
    }
    vector<bool> is_pr(1e5, true);
    vector<int> prim;
    for (int i = 2; i < 1e4; i++) {
        if (is_pr[i]) {
            prim.push_back(i);
            for (int j = i * i; j < 1e5; j += i) {
                is_pr[j] = false;
            }
        }
    }
    int ans = 0;
    vector<int> ch;
    for (int i = l; i <= r; i++) {
        if (i == x) {
            continue;
        }
        int d = gcd(i, x);
        int check = 1;
        for (auto j : prim) {
            if (j >= d) {
                break;
            }
            if (d % j == 0) {
                check = 0;
                break;
            }
        }
        if (check) {
            ans++;
            ch.push_back(i);
        }
    }
    cout << ans << "\n";
    for (auto i : ch) {
        cout << i << " ";
    }
    cout << "\n";
    return 0;
}
