#include <iostream>
#include <vector>
#include <set>

using namespace std;

int CONST = 1e9;

int main()
{
    int n, k;
    cin >> n >> k;
    vector<long long> a(n), pref(n + 1);
    pref[0] = 0;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        pref[i + 1] = pref[i] + a[i];
    }
    long long ans = 0;
    /*if (n <= 5000) {
        for (int i = 0; i < n; i++) {
            for (int j = i + 1; j <= n; j++) {
                if ((pref[j] - pref[i]) % k == 0) {
                    ans++;
                }
            }
        }
        cout << ans << "\n";
        return 0;
    }*/
    set<long long> r;
    for (int i = 0; i <= n; i++) {
        long long m = pref[i] % k;
        auto it = r.lower_bound(m * CONST);
        if (it != r.end() && (*it) < (m + 1) * CONST) {
            long long y = *it;
            r.erase(it);
            r.insert(y + 1);
        }
        else {
            r.insert(m * CONST + 1);
        }
    }
    for (auto x : r) {
        ans += (x % CONST) * (x % CONST - 1) / 2;
    }
    cout << ans << "\n";
    return 0;
}
