#include <iostream>
#include <vector>

bool isPrime(int a) {
    for(int i = 2;i * i <= a;++i) if(a % i == 0) return false;
    return true;
}

int gcd(int a, int b) {
    if(a % b == 0) return b;
    if(b % a == 0) return a;
    if(a > b) return gcd(a % b, b);
    return gcd(b % a, a);
}

int main() {
    int x, l, r;
    std::vector<int> ans;
    std::cin >> x >> l >> r;
    for(int y = l;y <= r;++y) {
        int d = gcd(x, y);
        //std::cout << y << " " << d << std::endl;
        if(x != y && isPrime(d)) ans.push_back(y);
    }
    std::cout << ans.size() << std::endl;
    for(int i : ans) std::cout << i << " ";
}
